Package: SMTrackR
Type: Package
Title: SMTrackR: an R/Bioconductor package for mapping protein binding
        at individual DNA molecules
Version: 1.1.0
Date: 2024-12-31
Authors@R: 
    c( person (given = "Aashna",
               family = "Bansal", 
               role = c("aut", "ctb"),
               email = "aashna_b@bt.iitr.ac.in"),
       person (given = "Himani",
               family = "Barmola", 
               role = c("aut", "ctb"),
               email = "km_h@bt.iitr.ac.in"),
       person (given = "Shivam",
               family = "Yadav", 
               role = c("aut", "ctb"),
               email = "shivam_y@bt.iitr.ac.in"),
       person (given = "Satyanarayan",
               family = "Rao", 
               role = c("aut", "cre"),
               email = "satyanarayan.rao@bt.iitr.ac.in",
               comment = c(ORCID="0000-0001-7678-3505"))
     )
Description: The package uses exogenous enzyme imprinted information to map protein-DNA binding on individual sequenced DNA molecules. For example, GpC methyltransferase, CpG methyltransferase, and Adenine methyltransferases. Public datasets from such assays are compiled into tracks, and hosted at public servers like Galaxy for their seamless access by this package.
biocViews: NucleosomePositioning, Visualization, GeneTarget,
        GenomeAssembly
Imports: jsonlite, GenomicRanges, rtracklayer, stringr, BiocFileCache,
        S4Vectors
License: MIT + file LICENSE
Suggests: knitr, rmarkdown, BiocStyle
VignetteBuilder: knitr
Encoding: UTF-8
RoxygenNote: 7.3.2
Depends: R (>= 4.5)
URL: https://www.raolab.in
BugReports: https://github.com/satyanarayan-rao/SMTrackR
Contact: mailto:satyanarayan.rao@bt.iitr.ac.in
git_url: https://git.bioconductor.org/packages/SMTrackR
git_branch: devel
git_last_commit: bff9c40
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-05-18
NeedsCompilation: no
Packaged: 2026-05-18 23:29:29 UTC; biocbuild
Author: Aashna Bansal [aut, ctb],
  Himani Barmola [aut, ctb],
  Shivam Yadav [aut, ctb],
  Satyanarayan Rao [aut, cre] (ORCID:
    <https://orcid.org/0000-0001-7678-3505>)
Maintainer: Satyanarayan Rao <satyanarayan.rao@bt.iitr.ac.in>
Built: R 4.6.0; ; 2026-05-19 05:10:11 UTC; unix

exportPattern("plotFootprints")
exportPattern("plotFootprintsUsingLocalBigBed")
exportPattern("plotMethylationCallsNanopore")
exportPattern("plotMethylationCallsNanoporeUsingLocalBigBed")
exportPattern("generateGvizCodeforSMF")
exportPattern("listTracks")


importFrom("jsonlite", "fromJSON")
importFrom("rtracklayer", "import")
importFrom("GenomicRanges", "resize")
importFrom("GenomicRanges", "findOverlaps")
importFrom("GenomicRanges", "width")
importFrom("S4Vectors", "from")
importFrom("S4Vectors", "to")
importFrom("stringr", "str_split")
importFrom("stringr", "str_length")
importFrom("stringr", "str_sub")
importFrom("stringr", "str_locate_all")
importFrom("stringr", "str_count")
importFrom("stringr", "str_replace_all")
importFrom("grDevices", "dev.copy", "dev.off", "pdf", "png",
           "postscript", "dev.control")
importFrom("utils", "head")
importFrom("graphics", "axis", "box", "image", "par", "segments",
           "text")
importFrom("utils", "download.file", "read.table", "write.table")
importFrom("BiocFileCache", "bfcrpath")

# SMTrackR

## Visualizing protein-DNA binding on individual sequenced DNA molecules.

Single-molecule assays like NOMe-seq, and dSMF are superior to DNase-seq and
ATAC-seq as they do not nibble down DNA. Thus, they enable quantification of
all three i.e., protein-free, Transcription Factor-bound and
histone-complex-bound states. But a user-friendly tool to visualize and
quantify such states is lacking. Here, we present, SMTrackR, a Bioconductor
package to visualize protein-DNA binding states on individual sequenced DNA
molecules. SMTrackR queries the single-molecule footprint database we built and
hosted at Galaxy Server. It comprises of BigBed files generated from NOMe-seq
and dSMF datasets. SMTrackR exploits UCSC REST API to query a BigBed file and
plot footprint heatmap categorized in different binding states as well as
report their occupancies.

List of tracks are available [here](https://docs.google.com/spreadsheets/d/1eu2Y2S0lyAUqxlvtnPBCO55OrxidYV7SwVRkqelPcKk/edit?gid=0#gid=0).

## Installation

Please use the following command to install this package in `R`

```
library(devtools)
devtools::install_github("satyanarayan-rao/SMTrackR", build_vignettes=TRUE, force=TRUE)
```

## Generating Protein-DNA binding Visualization


### Using data from mouse 8Cell stage

Pseudo-bulk signal is generated by merging all 8Cell scNOMe-seq data available from [Wang et al., Nat Commun., 2021](https://pubmed.ncbi.nlm.nih.gov/33623021/). 

```
library(SMTrackR)
SMTrackR::plotFootprints(organism = "mmusculus", model = "8cell", condition = "WT", 
               genome_assembly = "mm10", type = "SMF", chromosome = "chr5", 
               start = 113847750,  end  = 113847780, tr = "8cell", label = "remove_dup_true", 
               fp_cap = 50, remove_dup = T, target_dir = "smf")
```
NOTE: The heatmap will be saved in `smf/plots/remove_dup_true.heatmap.pdf`.

The `png` version of the plot is shown here. 


<img src="./plots/remove_dup_true.heatmap.png" alt="remove_dup" width="400">


### Using data from Drosophila Melanogaster S2 cells

Please use the command below to generate a heatmap centered at `chr2L:480290-480320` in _Drosophila Melanogaster_ S2 cells. Here dSMF data is sourced from [Krebs et al., Mol. Cell., 2017](https://pubmed.ncbi.nlm.nih.gov/28735898/).

```
library(SMTrackR)
SMTrackR::plotFootprints(target_dir = "dsmf")
```

The above command will generate `dsmf/plots/peak229.heatmap.pdf`. The `png` version is shown below. 

<img src="./plots/peak229.heatmap.png" alt="peak229" width="400">


### Using SMAC-seq data from Yeast

```
library(SMTrackR)
SMTrackR::plotMethylationCallsNanopore(target_dir = "nanopore")
```

The png version of the plot is shown below. 

<img src="./plots/smac_seq.heatmap.png" alt="nanopore" width="600">

## Visualizing on gene tracks

Because `Gviz` is a heavy package, we have not made ours to depend on this, but we generate a code that renders the heatmap below the gene track. Users are of course free to change the zoom level and add other tracks of their need. The generated code renders ideogram, axis, gene tracks and the heatmap highlight the center. It requires that you run the **`plotFootprints` function first**, so that it can use the heatmap data. Please look at the code below.

```
SMTrackR::plotFootprints(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm10", type = "SMF", chromosome = "chr1",
                         start = 191718250,  end = 191718280, tr = "16cell",
                         label = "tss", fp_cap = 50, remove_dup = F, target_dir = "smf")
SMTrackR::generateGvizCodeforSMF(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm10", type = "SMF", chromosome = "chr1",
                         start = 191718250,  end = 191718280, tr = "16cell",
                         label = "tss", fp_cap = 50, remove_dup = F, gviz_left = 500, 
                         gviz_right = 500, target_dir = "smf")
```

The png version of `smf/plots/tss.gviz.pdf` is shown below. 

NOTE: `R` script written by `generateGvizCodeforSMF` code uses Nov 2020 Ensembl Archive, which is currently not available (at least from last two weeks). Our bigBed tracks are built on mm9 and mm10 assemblies, so we can't use the latest (may2025) archive which maps `mm39`. The plot below was generated with functional [nov2020.archive.ensembl.org](nov2020.archive.ensembl.org).

<img src="./plots/tss.gviz.png" alt="nanopore" width="600">

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(echo = TRUE)
options(warn=-1)

## ----echo=FALSE, out.width="70%", fig.align="center"--------------------------
knitr::include_graphics("images/schematic_for_vignettes.png")

## ----echo = TRUE--------------------------------------------------------------
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("SMTrackR")
# rmarkdown::html_vignette

## ----Load package, echo=TRUE--------------------------------------------------
library(SMTrackR)

## ----plot psuedo-bulk scNOMe-seq data, fig.width=4.5, fig.height=6, echo=TRUE----
SMTrackR::plotFootprints(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm39", type = "SMF", chromosome = "chr1",
                         start = 191450362,  end = 191450392, tr = "16cell",
                         label = "tss_mm39", fp_cap = 50, remove_dup = FALSE, target_dir = "smf")
SMTrackR::generateGvizCodeforSMF(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm39", type = "SMF", chromosome = "chr1",
                         start = 191450362,  end = 191450392, tr = "16cell",
                         label = "tss_mm39", fp_cap = 50, remove_dup = FALSE, gviz_left = 500,
                         gviz_right = 500, target_dir = "smf")

## ----echo=FALSE, out.width="100%", fig.align="center"-------------------------
knitr::include_graphics("images/tss_mm39.gviz.png")

## ----Plot dSMF data, fig.width=4.5, fig.height=6, echo=TRUE-------------------
SMTrackR::plotFootprints(target_dir = "dsmf")

## ----echo=FALSE, out.width="100%", fig.align="center"-------------------------
knitr::include_graphics("images/peak229.heatmap.png")

## ----Plot Methylation Calls on Nanopore Reads, fig.width=10, fig.height=5, echo=TRUE----
SMTrackR::plotMethylationCallsNanopore(target_dir = "nanopore") 

## ----echo=FALSE, out.width="100%", fig.align="center"-------------------------
knitr::include_graphics("images/smac_seq.heatmap.png")

## ----List available tracks, echo = TRUE---------------------------------------

#SMTrackR::listTracks()

## ----Session Info, echo = TRUE------------------------------------------------
sessionInfo()

writeIntermediateFiles <- function (ordered_by_length = NULL,
                                    label = "peak229", target_dir = "") {
    write.table(ordered_by_length,
                file = paste(target_dir, 
                             paste0(label, "_labelled_and_ordered.tsv"), 
                             sep = "/"),
                sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
    num_coverted_fp <- unlist (lapply(ordered_by_length$fp_vec,
                                      function (x) {convert_fp_char_to_num(x)}))
    num_coverted_m <- unlist (lapply(ordered_by_length$m_vec,
                                     function (x) {convert_m_char_to_num(x)}))
    num_fp_df <- data.frame(read_id = ordered_by_length$read_id,
                            num_coverted_fp = num_coverted_fp)
    num_mvec_df <- data.frame(read_id = ordered_by_length$read_id,
                              num_coverted_m = num_coverted_m)
    write.table (num_fp_df, 
                 file = paste(target_dir, paste0(label, ".num.fp.tsv"), sep ="/"),
                 sep = "\t", row.names = FALSE,
                 col.names = FALSE, quote = FALSE)
    write.table (num_mvec_df, 
                 file = paste(target_dir, paste0(label, ".num.mvec.tsv"), sep ="/"),
                 sep = "\t", row.names = FALSE,
                 col.names = FALSE, quote = FALSE)
}

writeBindingStatesFiles <- function (
        processed_df = NULL,
        label = "peak229",
        fp_cap = 50, span_left = 150, span_right = 150,
        target_dir = ""){
    
    ofp <- file (paste(target_dir, 
                       paste0(label, "_assigned_states.tsv"), sep = "/"), "w")
    ofp_verbose <- file (paste(target_dir, 
                               paste0(label, "_verbose.tsv"), sep = "/"), "w")
    max_length_vec <- c()
    read_info_vec <- c()
    abs_start_vec <- c()
    fp_vec <- c ()
    m_vec <- c()
    binding_state_vec <- c()
    flag_vec <- c()
    
    for (idx in seq (nrow(processed_df)) ){
        line <- paste (processed_df[idx, ], collapse = "\t")
        #print (line)
        assigned_states <- assign_binding_states(line, fp_cap = fp_cap)
        #print (assigned_states)
        cat (assigned_states$labelled, file = ofp, append = TRUE)
        cat("\n", file = ofp, append = TRUE)
        #print (assigned_states$read_id)
        ## Generate the fp extended file
        sub_molecule_fp <- assigned_states$intersected_fp_str
        sub_molecule_m <- assigned_states$intersected_m_str
        complete_molecule_fp <- assigned_states$complete_fp_str
        complete_molecule_m <- assigned_states$complete_m_str
        read_id <- assigned_states$read_id
        abs_roi_start <- assigned_states$abs_roi_start
        abs_roi_end <- assigned_states$abs_roi_end
        abs_read_start <- assigned_states$abs_read_start
        abs_read_end <- assigned_states$abs_read_end
        label_id <- assigned_states$label_id
        chrQ <- assigned_states$chrQ
        marker <- paste0(chrQ,":", abs_roi_start, "-", abs_roi_end, "`",
                         read_id, "#", label_id)
        extended_fp <- extend_fp_from_center(
            sub_moleculue = sub_molecule_fp,
            complete_molecule = complete_molecule_fp,
            abs_roi_start = abs_roi_start,
            abs_roi_end = abs_roi_end,
            abs_complete_molecule_start = abs_read_start,
            abs_complete_molecule_end = abs_read_end,
            lextend = span_left, rextend = span_right)
        extended_m <- extend_fp_from_center(
            sub_moleculue = sub_molecule_m,
            complete_molecule = complete_molecule_m,
            abs_roi_start = abs_roi_start,
            abs_roi_end = abs_roi_end,
            abs_complete_molecule_start = abs_read_start,
            abs_complete_molecule_end = abs_read_end,
            lextend = span_left, rextend = span_right)
        cat(paste0(marker, "\t", extended_fp, "\t", extended_m),
            file = ofp_verbose, append = TRUE)
        cat ("\n", file = ofp_verbose, append =  TRUE)
        
        tmp <- unlist(strsplit(marker, split = "`"))
        flag_and_state <- unlist(strsplit(tmp[length(tmp)], split = "#"))
        flag <- flag_and_state[1]
        state <- flag_and_state[2]
        fp_without_m <- str_replace_all(extended_fp, "M", ".")
        fp_info <- fp_info_for_complete_molecule(fp_without_m)
        if (length(fp_info$just_length_vec) > 0){
            max_length <- max (fp_info$just_length_vec)
            which_max <- which.max (fp_info$just_length_vec)
            read_info_vec <- c(read_info_vec, marker)
            max_length_vec <- c (max_length_vec, max_length)
            abs_start_vec <- c (abs_start_vec,
                                fp_info$fp_start_locus[which_max])
            fp_vec <- c(fp_vec, extended_fp)
            m_vec <- c(m_vec, extended_m)
            flag_vec <- c(flag_vec, flag)
            binding_state_vec <- c(binding_state_vec, state)
        }else {
            read_info_vec <- c(read_info_vec, marker)
            max_length_vec <- c (max_length_vec, 0)
            abs_start_vec <- c(abs_start_vec, (0 - span_left) )
            fp_vec <- c(fp_vec, extended_fp)
            m_vec <- c(m_vec, extended_m)
            flag_vec <- c(flag_vec, flag)
            binding_state_vec <- c(binding_state_vec, state)
        }
        
    }
    close(ofp)
    close(ofp_verbose)
    length_and_read_info_df <- data.frame(read_id = read_info_vec,
                                          binding_state_vec = binding_state_vec,
                                          flag_vec = flag_vec,
                                          max_fp_length = max_length_vec,
                                          abs_start_vec = abs_start_vec,
                                          fp_vec = fp_vec,
                                          m_vec = m_vec)
    return (length_and_read_info_df)
    
    
}

savePlotSMForDSMF <- function (label = "peak229",
                               span_left = 150, span_right = 150, 
                               plot_title = "dmelanogaster S2 WT",
                               x_label = "peak229 (dm6 chr2L:480290-480320)",
                               target_dir = ""){
    dat_for_plot <- read.table(paste(target_dir, paste0(label, ".num.fp.tsv"),
                                     sep = "/"),
                               sep = "\t", header = FALSE,
                               stringsAsFactors = FALSE,
                               row.names = 1, comment.char = "%")
    dat_for_plot <- dat_for_plot[!grepl("#3", row.names (dat_for_plot)), ]
    #reverse the dataframe: bring bottom row to the top
    #remove not valid states i.e. state 3 for now.
    
    dat_for_plot <- apply(dat_for_plot, 2, rev)
    
    main_dir <- target_dir
    if (!dir.exists(main_dir)){
        dir.create(main_dir, recursive = TRUE)
    }
    plot_dir <- paste(main_dir, "plots", sep = "/")
    if (!dir.exists(plot_dir)){
        dir.create(plot_dir, recursive = TRUE)
    }
    
    all_valid_states <- data.frame(table(
        unlist(lapply (row.names(dat_for_plot),
                       function (x) {
                           as.integer(unlist(strsplit(x, split= "#"))[-1]) }))))
    names(all_valid_states) <- c("state", "count")
    state_info <- c("2" = "N", "1" = "T", "0" = "D")
    all_valid_states$state_label <- unlist(
        lapply (all_valid_states$state,
                function (x){state_info[as.character(x)]}))
    all_valid_states$line_loc <- rev(cumsum(rev(all_valid_states$count)))
    all_valid_states$prev_point <- c(all_valid_states$line_loc[-1], 0)
    all_valid_states$label_loc <- (all_valid_states$line_loc +
                                       all_valid_states$prev_point)/2
    all_valid_states$percentage <- all_valid_states$count /
        sum (all_valid_states$count)
    all_valid_states$total <- sum (all_valid_states$count)
    all_valid_states$annotation <- label
    write.table(all_valid_states,
                file.path(plot_dir, paste0(label, ".states.tsv")),
                row.names = FALSE, col.names = TRUE, sep = "\t", quote = FALSE)
    total_molecules <- nrow(dat_for_plot)
    
    dat_matrix <- as.matrix (dat_for_plot)
    x_width <- span_left + span_right + 1
    if (nrow(dat_matrix) > 15){
        
        pdf (file.path(plot_dir, paste0(label, ".heatmap.pdf")),
             height = 6, width = 4.5, bg = "white")
        dev.control("enable")
        par(mgp=c(1.5,0.25,0), cex = 0.75)
        image(seq(1,ncol(dat_matrix)), seq(1,nrow(dat_matrix)), t(dat_matrix),  
              axes = FALSE, useRaster = TRUE,
              oldstyle = FALSE, col = c("-1" = "#bdbdbd", "0" = "#FFFFFF",
                                        "1"  = "Red" , "2" = "#2b8cbe"),
              xlim = c(-30, x_width), xlab = paste0("           ", x_label), 
              ylab = "", main = paste0("      ", plot_title))
        
        
        counter <- 1
        for (i in rev(seq (nrow(all_valid_states)) )){
            line_loc <- all_valid_states[i, "line_loc"]
            label_loc <- all_valid_states[i, "label_loc"]
            state_label <- all_valid_states[i, "state_label"]
            cnt <- all_valid_states[i, "count"]
            
            if (counter < nrow(all_valid_states)) {
                segments(-30, (line_loc + 0.5), x_width,
                         (line_loc + 0.5), lwd = 0.5)
            }
            if (counter == 1) {
                text(-15, label_loc, paste0 ("State ",  state_label,
                                             " ( n = ", cnt, ")"), srt = 90)
            }else{
                text(-15, label_loc, paste0 (state_label,
                                             " (", cnt, ")"), srt = 90)
            }
            counter <- counter + 1
        }
        
        
        
        # Draw vertical red line +/- 15 bases from `0`
        segments((span_left - 15) , 0, (span_left - 15),
                 (total_molecules + 0.5), lwd = 0.5, col = "Red")
        segments((span_left + 15), 0, (span_left + 15),
                 (total_molecules + 0.5), lwd = 0.5, col = "Red")
        ticks_at <- seq(0, span_left + span_right, 50)
        lab_at_ticks <- as.character(ticks_at - as.integer(
            (span_left + span_right)/2))
        axis(1, ticks_at,
             lab_at_ticks,
             srt = 2, cex.lab = 0.5, tck = -0.01, tick = FALSE)
        
        box(lwd=0.5)
        
        #saveToPDF(file.path(plot_dir, paste0(label, ".heatmap.pdf")),
        #          height = 6, width = 4.5)
        #saveToPNG(file.path(plot_dir, paste0(label, ".plot.png")),
        #          height = 6, width = 4.5, units = "in", res = 300)
        #saveToEPS(file.path(plot_dir, paste0(label, ".heatmap.eps")),
        #          height = 6, width = 4.5,
        #          horizontal = FALSE, paper = "special")
        dev.copy(postscript, file.path(plot_dir, paste0(label, ".heatmap.eps")),
                 height = 6, width = 4.5, 
                 horizontal = FALSE, paper = "special")
        dev.control("enable")
        
        dev.copy(png, file.path(plot_dir, paste0(label, ".heatmap.png")),
                 height = 6, width = 4.5, units = "in", res = 300)
        dev.off()
        dev.off()
        dev.off()
        message (paste0("Heatmap is saved in the file ", 
                    file.path(plot_dir, paste0(label, ".heatmap.pdf"))))
        message ("\n")
        
    }else {
        
        pdf (file.path(plot_dir, paste0(label, ".heatmap.pdf")),
             height = 6, width = 4.5, bg = "white")
        dev.control("enable")
        par(mgp=c(1.5,0.25,0), cex = 0.75)
        plot(c(0, 1), c(0, 1), ann = FALSE, bty = 'n', type = 'n',
             xaxt = 'n', yaxt = 'n');
        text(x = 0.5, y = 0.5, paste0("Only ", nrow (dat_matrix),
                                      " molecules, not enough for plotting"))
        
        dev.copy(postscript, file.path(plot_dir, paste0(label, ".heatmap.eps")),
                 height = 6, width = 4.5, 
                 horizontal = FALSE, paper = "special")
        dev.control("enable")
        
        dev.copy(png, file.path(plot_dir, paste0(label, ".plot.png")),
                  height = 6, width = 4.5, units = "in", res = 300)
        dev.off()
        dev.off()
        dev.off()
        message (paste0("Heatmap is saved in the file ", 
                    file.path(plot_dir, paste0(label, ".heatmap.pdf"))))
        message ("\n")
        
    }
    return (file.path(plot_dir, paste0(label, ".heatmap.pdf")))
}

fp_info_for_complete_molecule  <- function (
        footprint_string = "F...FFFF...FFF.....FFFFF."){
    # use stringr library
    first_char <- substr(footprint_string,1,1)
    footprint_loci <- data.frame(str_locate_all(footprint_string, "\\.F"))
    st <- footprint_loci$start
    en <- footprint_loci$end
    st <- st + 1
    if (first_char == "F"){
        st <- c (1, st)
    }
    
    #print (st)
    total_length <- str_length(footprint_string)
    fp_len_vec <- rep(0, total_length)
    abs_fp_start_vec <- rep(0, total_length)
    just_length_vec <- c()
    for (k in st){
        cnt <- 0
        bp <- k
        for (i in seq (k,total_length)){
            char_i <- substr(footprint_string, i,i)
            if (char_i == "."){
                break
            }else {
                cnt <- cnt + 1
                abs_fp_start_vec [i] <- k
                bp <- i
            }
        }
        
        fp_len_vec[k:bp] <- cnt
        just_length_vec <- c(just_length_vec, cnt)
        abs_fp_start_vec[k:bp] <- k
    }
    return (list(fp_len_at_each_pos = fp_len_vec,
                 just_length_vec = just_length_vec,
                 fp_start_locus = st,
                 abs_fp_start_vec = abs_fp_start_vec))
}

locate_fp_start  <- function (footprint_string = "F...FFFF...FFF.....FFFFF."){
    # use stringr library
    first_char <- substr(footprint_string,1,1)
    footprint_loci <- data.frame(str_locate_all(footprint_string, "\\.F"))
    st <- footprint_loci$start
    en <- footprint_loci$end
    st <- st + 1
    if (first_char == "F"){
        st <- c (1, st)
    }
    return (st)
}


fp_info_for_sub_molecule <- function (
        query_footprint = "FF...FFF.....FF",
        query_start = 7,
        query_end = 21,
        complete_footprint = "F...FFFF...FFF.....FFFFF."){
    fp_start_loci_on_query <- locate_fp_start(
        footprint_string = query_footprint)
    fp_info_complete_fp <- fp_info_for_complete_molecule(complete_footprint)
    fp_len_at_each_pos <- fp_info_complete_fp$fp_len_at_each_pos
    abs_fp_start_at_each_pos <- fp_info_complete_fp$abs_fp_start_vec
    abs_fp_start_in_query <- abs_fp_start_at_each_pos[query_start:query_end]
    fp_len_query <- c()
    for (i in fp_start_loci_on_query){
        idx_on_long_molecule <- i + query_start - 1
        fp_len_query <- c (fp_len_query,
                           fp_len_at_each_pos[idx_on_long_molecule])
    }
    return (list (fp_len_query = fp_len_query,
                  fp_start_loci_on_query = fp_start_loci_on_query,
                  abs_fp_start_in_query = abs_fp_start_in_query))
}

extend_fp_from_center <- function (
        sub_moleculue = "FF...FFF.....FF",
        complete_molecule = "F...FFFF...FFF.....FFFFF.",
        abs_roi_start = 7, abs_roi_end = 21, abs_complete_molecule_start = 1,
        abs_complete_molecule_end = 25, lextend = 30,
        rextend = 30, strand = "+") {
    rel_roi_start <- abs_roi_start - abs_complete_molecule_start + 1
    rel_roi_end <- abs_roi_end - abs_complete_molecule_start + 1
    peak_center <- as.integer((rel_roi_start + rel_roi_end)/2)
    len_complete_molecule <- str_length(complete_molecule)
    m_to_add_in_left <- abs (min ( (peak_center - 1) - lextend, 0))
    m_to_add_in_right <- abs ( min (
        len_complete_molecule - (peak_center + rextend), 0 ) )
    extended_sub_molecule_left <- NULL
    extended_sub_molecule_right <- NULL
    if (m_to_add_in_left > 0){
        extended_sub_molecule_left <- 1
    }else {
        extended_sub_molecule_left <- peak_center - lextend
    }
    if (m_to_add_in_right > 0){
        extended_sub_molecule_right <- len_complete_molecule
    }else{
        extended_sub_molecule_right <- peak_center + rextend
    }
    extended_sub_molecule <- str_sub(complete_molecule,
                                     extended_sub_molecule_left,
                                     extended_sub_molecule_right)
    
    final_string <- paste0(paste0(rep("M", m_to_add_in_left), collapse = ""),
                           extended_sub_molecule,
                           paste0(rep("M", m_to_add_in_right), collapse = "" ),
                           collapse = "")
}
expand_cigar_string <- function (cigar_string = ".131F52.77F35.5"){
    idx_vec <- c()
    char_vec <- c()
    for(i in seq (1, nchar(cigar_string))) {
        char <- substr(cigar_string,i,i)
        if (!(char %in% as.integer(0:9))){
            idx_vec <- c(idx_vec, i)
            char_vec <- c(char_vec, char)
        }
    }
    num_rep <- c()
    rept_vec <- c ()
    length_cigar_string <- str_length(cigar_string)
    if (length(idx_vec) == 1) {
        if (length_cigar_string > 1){
            rept <- as.integer(substr(cigar_string, 2, length_cigar_string))
            expand_cigar <- paste0 (rep(char_vec[1], rept), collapse = "")
            return (expand_cigar)
        }else { return (cigar_string) }
    }else {
        for (j in seq(1,(length(idx_vec) - 1)) ){
            idx_c <- idx_vec[j]
            idx_n <- idx_vec[j+1]
            if (idx_n - idx_c == 1){
                rept_vec <- c(rept_vec, "1")
            }else{
                num_rep <- c(num_rep, j)
                rept <- substr(cigar_string, idx_c + 1, idx_n - 1)
                rept_vec <- c (rept_vec, rept)
            }
        }
    }
    idx_l <- idx_vec[length(idx_vec)]
    if (idx_l < nchar(cigar_string)){
        rept_l <- substr(cigar_string, idx_l+1, nchar(cigar_string))
        rept_vec <- c(rept_vec, rept_l)
    }
    expand_cigar <- c()
    for (k in seq(1, length(rept_vec))) {
        k_rep <- as.integer(rept_vec[k])
        char_ex <- char_vec[k]
        expand_cigar <- c (expand_cigar, rep(char_ex, k_rep))
    }
    if (length(char_vec) > length(rept_vec)){
        expand_cigar <- c(expand_cigar, char_vec[length(char_vec)])
    }
    expand_cigar <- paste0(expand_cigar, collapse = "")
    return (expand_cigar)
}



add_footprints_on_edges <- function(methylation_string = "..Z..x..Z...",
                                    footprint_string = "...FFFFF....") {
    len_vec <- nchar(methylation_string)
    left_border <- 0
    right_border <- 0
    cnt <- 0
    for (i in seq_len(len_vec)) {
        char <- substr(methylation_string, i, i)
        if (char == "." || char == tolower(char)) {
            cnt <- cnt + 1
        } else if (char == toupper(char)) { break }
    }
    left_border <- cnt
    cnt <- 0
    for (i in seq(len_vec, 1, -1)) {
        char <- substr(methylation_string, i, i)
        if (char == "." || char == tolower(char)) {
            cnt <- cnt + 1
        } else if (char == toupper(char)) { break }
    }
    right_border <- len_vec - cnt + 1
    if (left_border == len_vec) {
        left_border <- 0
        right_border <- 0
    }
    rep_v <- "F"
    if (left_border == 0  && right_border == 0) {
        o_str <- paste0(rep(rep_v, len_vec), collapse = "")
    } else {
        if (left_border > 0 && right_border > 0) {
            o_str <- paste0(
                paste(rep(rep_v, left_border), collapse = ""),
                substr(footprint_string, (left_border + 1),
                       (right_border - 1) ),
                paste(rep(rep_v, (len_vec - right_border + 1) ),
                      collapse = ""))
        }else{
            if (left_border > 0 && right_border == 0){
                o_str <- paste0(
                    paste(rep(rep_v, left_border), collapse = ""),
                    substr(footprint_string, (left_border + 1) , len_vec),
                    collapse ="")
            }else{
                if (left_border == 0 && right_border > 0){
                    o_str <- paste0(substr(footprint_string,1,(right_border-1)),
                                    paste(rep(rep_v,
                                              (len_vec - right_border + 1))),
                                    collapse = "")
                }
            }
        }
    }
    return(o_str)
}

get_count_and_percentage_methylation <-function (methylation_vector = ""){
    total <- 0
    total_lower <- 0
    total_upper <- 0
    per_c <- 0
    total_length <- str_length(methylation_vector)
    for (idx_char in seq (1, total_length) ){
        char <- str_sub(methylation_vector, idx_char, idx_char)
        if (char == "." || char == "M"){ # M is just the fill-in (M: missing)
            next
        }else if (tolower(char) == char){
            total  <- total + 1
            total_lower <- total_lower + 1
            
        }else {
            total <- total + 1
            total_upper <- total_upper + 1
        }
    }
    if (total > 0){
        per_c <- as.character(round (total_upper/total, 3) * 100)
    }else {
        per_c <- "NA"
    }
    return (list (per_c = per_c, total_upper = total_upper,
                  total_lower = total_lower, total = total))
}

capital_percentage_and_stretch_of_unbound <- function (methylation_vector = ""){
    total_length <- str_length(methylation_vector)
    check_vector <- paste0(rep(".", total_length), collapse = "")
    total_capital <- 0
    total_small <- 0
    left_extreme <- 1
    right_extreme <- total_length
    first_found <- FALSE
    base_counter <- -1
    last_capital <- -1
    for (idx_char in seq (1, total_length)){
        char <- str_sub(methylation_vector, idx_char, idx_char)
        base_counter <- base_counter + 1
        
        if (char == "."){
            next
        } else if (char == tolower(char)) {
            total_small <- total_small + 1
        } else if (char == toupper(char)){
            total_capital <- total_capital + 1
            if (first_found == FALSE){
                left_extreme <- base_counter
                first_found <- TRUE
            } else {
                last_capital <- base_counter
            }
        } else {
            next
        }
        
    }
    naked_dna_stretches <- c()
    if (first_found == TRUE) {
        if (last_capital == -1){
            naked_dna_stretches <- c (naked_dna_stretches, left_extreme)
            naked_dna_stretches <- c (naked_dna_stretches, 0)
            naked_dna_stretches <- c (right_extreme - left_extreme)
        } else {
            naked_dna_stretches <- c (naked_dna_stretches, left_extreme)
            naked_dna_stretches <- c (naked_dna_stretches,
                                      last_capital - left_extreme) # check if -1 is required
            naked_dna_stretches <- c (naked_dna_stretches,
                                      right_extreme - last_capital) # check if -1 is required
        }
    }else {
        naked_dna_stretches <- c(0,0,0)
        
    }
    total <- total_capital + total_small
    percentage_capital <- "NA"
    if (total > 0) {
        percentage_capital <- round (total_capital/total, 2)
    }
    return (list (total_length = total_length,
                  total = total,
                  percentage_capital = percentage_capital,
                  naked_dna_stretches = naked_dna_stretches))
}

get_percent_for_each_footprint <- function (footprint_vector = ""){
    flen_vec <- c()
    cnt <- 0
    f_switch <- FALSE
    total_length <- str_length(footprint_vector)
    for (idx_char in seq (1, total_length)){
        char <- str_sub(footprint_vector, idx_char, idx_char)
        if (char == "F"){
            cnt <- cnt + 1
            f_switch <- TRUE
        }else{
            if (cnt != 0){
                per <- round ((cnt/total_length)*100, 2)
                cnt <- 0
                flen_vec <- c (flen_vec, per)
            }
        }
        
    }
    if (cnt != 0){
        per <- round ((cnt/total_length)*100, 2)
        flen_vec <- c (flen_vec, per)
    }
    return (flen_vec)
}

assign_binding_states <- function (overlap_string = "",
                                   lextend = 30, rextend = 30,
                                   fp_cap = 50){
    all_info <- unlist (str_split(overlap_string, pattern = "\t"))
    labels_for_info <- c("chrQ", "abs_roi_start", "abs_roi_end",
                        "chrS", "abs_read_start", "abs_read_end",
                        "read_id", "score", "strand", "complete_fp_str",
                        "complete_m_str")
    chrQ <- all_info[1]
    abs_roi_start <- as.integer(all_info[2])
    abs_roi_end <- as.integer(all_info[3])
    chrS <- all_info[4]
    abs_read_start <- as.integer(all_info[5])
    abs_read_end <- as.integer(all_info[6])
    read_id <- all_info[7]
    score <- all_info[8]
    strand <- all_info[9]
    complete_fp_str <- all_info[10]
    complete_m_str <- all_info[11]
    rel_roi_start <- abs_roi_start - abs_read_start + 1
    rel_roi_end <- abs_roi_end - abs_read_start  + 1
    intersected_fp_str <- str_sub (complete_fp_str, rel_roi_start, rel_roi_end)
    intersected_m_str <- str_sub (complete_m_str, rel_roi_start, rel_roi_end)
    
    #stop("here")
    fp_info_query <- fp_info_for_sub_molecule (
        query_footprint = intersected_fp_str,
        query_start = rel_roi_start,
        query_end = rel_roi_end,
        complete_footprint = complete_fp_str)
    total_length <- str_length(complete_fp_str)
    half_of_query <- as.integer ((rel_roi_end - (rel_roi_start - 1))/2)
    left_neighbor <- extend_fp_from_center(
        sub_moleculue = intersected_m_str,
        complete_molecule = complete_m_str,
        abs_roi_start = abs_roi_start,
        abs_roi_end = abs_roi_end,
        abs_complete_molecule_start = abs_read_start,
        abs_complete_molecule_end = abs_read_end,
        lextend = lextend,
        rextend = half_of_query, strand = strand)
    right_neighbor <- extend_fp_from_center(
        sub_moleculue = intersected_m_str,
        complete_molecule = complete_m_str,
        abs_roi_start = abs_roi_start,
        abs_roi_end = abs_roi_end,
        abs_complete_molecule_start = abs_read_start,
        abs_complete_molecule_end = abs_read_end,
        lextend = half_of_query,
        rextend = rextend, strand = strand)
    info_for_left <- get_count_and_percentage_methylation(left_neighbor)
    info_for_right <- get_count_and_percentage_methylation(right_neighbor)
    percentage_methylation <- "NA"
    per_capital_l <- info_for_left$per_c
    total_upper_l <- info_for_left$total_upper
    total_lower_l <- info_for_left$total_lower
    total_l <- info_for_left$total
    per_capital_r <- info_for_right$per_c
    total_upper_r <- info_for_right$total_upper
    total_lower_r <- info_for_right$total_lower
    total_r <- info_for_right$total
    
    if (per_capital_l !="NA" && per_capital_r !="NA"){
        if (as.numeric (per_capital_l) <= as.numeric(per_capital_r)) {
            percentage_methylation <- per_capital_l
        }else {
            percentage_methylation <- per_capital_r
        }
    }else if (per_capital_l == "NA" && per_capital_r != "NA") {
        percentage_methylation <- per_capital_r
    } else if (per_capital_l != "NA" && per_capital_r == "NA"){
        percentage_methylation <- per_capital_l
    } else{
        percentage_methylation <- "0"
    }
    percentage_methylation <- as.numeric(percentage_methylation)
    
    #   return (list (per_c = per_c, total_upper = total_upper,
    #                  total_lower = total_lower, total = total))
    edge_info <- capital_percentage_and_stretch_of_unbound(complete_m_str)
    complete_m_str_len <- edge_info$total_length
    total_letters_on_complete_m_str <- edge_info$total
    ratio_capital_letters <- edge_info$percentage_capital
    edges <- edge_info$naked_dna_stretches
    max_of_edges <- max (edges[1], edges[2])
    intersect_len <- str_length(intersected_fp_str)
    indiv_fp_percent <- get_percent_for_each_footprint(intersected_fp_str)
    total_percent_fp_in_intersect <- round ((
        str_count(intersected_fp_str,
                  "F")/intersect_len)*100, 3)
    labels_on_reads <- c()
    label <- "NA"
    labelled <- "NA"
    label_list <- list ("Naked_DNA" = 0, "TF" = 1,
                        "Nuc" = 2, "discard" = 3)
    if (length(indiv_fp_percent) == 0){
        labelled <- paste(overlap_string, intersected_fp_str, "0.0", "0",
                          label_list$Naked_DNA, total_length, sep = "\t")
        label <- "Naked_DNA"
    }else{
        max_contribution_in_the_intersect <- which.max(indiv_fp_percent)
        max_percentage_overlap <- indiv_fp_percent[
            max_contribution_in_the_intersect]
        length_of_max_contribution <- fp_info_query$fp_len_query[
            max_contribution_in_the_intersect]
        abs_start_loc_of_max <- fp_info_query$fp_start_loci_on_query[
            max_contribution_in_the_intersect]
        abs_fp_start_on_complete_fp <- fp_info_query$abs_fp_start_in_query[
            abs_start_loc_of_max]
        if (total_percent_fp_in_intersect <= 30 &&
            percentage_methylation > 25){
            labelled = paste(overlap_string, intersected_fp_str,
                             max_percentage_overlap,
                             length_of_max_contribution,
                             label_list$Naked_DNA, total_length, sep = "\t")
            label <- "Naked_DNA"
        }else if (total_percent_fp_in_intersect <=30 &&
                  percentage_methylation <=25){
            labelled <- paste(overlap_string, intersected_fp_str,
                              max_percentage_overlap,
                              length_of_max_contribution,
                              label_list$Nuc, total_length, sep = "\t")
            label <- "Nuc"
        }else if (total_percent_fp_in_intersect > 30 &&
                  length_of_max_contribution <=fp_cap){
            
            if ( (abs_fp_start_on_complete_fp +
                  length_of_max_contribution - 1) == total_length
                 || abs_fp_start_on_complete_fp == 1) {
                labelled <- paste(overlap_string,
                                  intersected_fp_str, max_percentage_overlap,
                                  length_of_max_contribution,
                                  label_list$discard, total_length, sep = "\t")
                label <- "discard"
            }else {
                labelled <- paste(overlap_string, intersected_fp_str,
                                  max_percentage_overlap,
                                  length_of_max_contribution,
                                  label_list$TF, total_length, sep = "\t")
                label <- "TF"
            }
        }else if (length_of_max_contribution > fp_cap){
            labelled <- paste(overlap_string, intersected_fp_str,
                              max_percentage_overlap,
                              length_of_max_contribution,
                              label_list$Nuc, total_length, sep = "\t")
            label <- "Nuc"
        }
    }
    label_id <- label_list[[label]]
    return (list(labelled = labelled,
                 label = label,
                 label_id = label_id,
                 read_id = read_id,
                 intersected_fp_str = intersected_fp_str,
                 intersected_m_str = intersected_m_str,
                 abs_roi_start = abs_roi_start,
                 abs_roi_end = abs_roi_end,
                 abs_read_start = abs_read_start,
                 abs_read_end = abs_read_end,
                 complete_fp_str = complete_fp_str,
                 complete_m_str = complete_m_str,
                 chrQ = chrQ))
}

convert_fp_char_to_num <- function (char_vector = "MMM...FF...FFEEEEMMM"){
    total_len <- str_length(char_vector)
    num_vec <- c()
    for (i in seq (total_len)){
        char <- str_sub(char_vector, i, i)
        if (char == "."){
            num_vec <- c (num_vec, 0)
        }else if (char == "M"){
            num_vec <- c (num_vec, -1)
        }else if (char == "F" || char == "E"){
            num_vec <- c (num_vec, 1)
        }
    }
    ret = paste0(num_vec, collapse = "\t")
    return (ret)
}

convert_m_char_to_num <- function (char_vector = "MMM...x..X..H...hh...MMMM"){
    total_len <- str_length(char_vector)
    num_vec <- c()
    for (i in seq (total_len)){
        char <- str_sub(char_vector, i, i)
        if (char == "."){
            num_vec <- c(num_vec, 0)
        }else if (char == "M"){
            num_vec <- c (num_vec, -1)
        } else if (char == tolower(char)){
            num_vec <- c (num_vec, 1)
        }else {
            num_vec <- c (num_vec, 2)
        }
    }
    ret = paste0(num_vec, collapse = "\t")
    return (ret)
}
saveToPDF <- function(...) {
    d <- dev.copy(pdf,...);
    dev.off(d);
}

saveToPNG <- function(...) {
    d <- dev.copy(png,...);
    dev.off(d);
}

saveToEPS <- function(...) {
    d <- dev.copy(postscript,...);
    dev.off(d);
}
label_list <- list ("Naked_DNA" = 0, "TF" = 1,
                    "Nuc" = 2, "discard" = 3)
getHubURL <- function (organism = "dmelanogaster",
                       model = "S2", condition = "WT", type = "dSMF",
                       genome_assembly = "dm6", tr = "fp_and_mvec"){
    row.names (hubs) <- paste(hubs$Organism, hubs$model,
                              hubs$Condition, hubs$Type,
                              hubs$Genome, hubs$Track, sep = "@")
    
    identifier <- paste(organism, model, condition, type,
                        genome_assembly, tr, sep = "@")
    track_url <- hubs[identifier, "Hub_URL"]
    track_url <- paste0("https://api.genome.ucsc.edu/getData/track?hubUrl=",
                        track_url)
    return (track_url)
}
remove_duplicate_molecules <- function (fp_file = "peak229.all_fp.bed",
                                        label = "peak229", target_dir = ""){
    # the data is coming from big bed file, so the coordinates
    # are ought to be sorted
    dt <- read.table(fp_file, sep = "\t", header = FALSE,
                     stringsAsFactors = FALSE)
    dt ["srr"] <-  unlist (lapply (dt$V4, function (x) {
        unlist (strsplit (x, split = "\\."))[[1]]}))
    dt["mol"] <- unlist (lapply (dt$V4,
                                 function (x) {unlist (
                                     strsplit (x, split = "`"))[[2]]}))
    idx_duplicate <- which (duplicated(dt[, c ("V1", "V2", "V3",
                                               "srr", "mol")]))
    uniq_mol_df <- dt[-idx_duplicate, ]
    dup_mol_df <- dt[idx_duplicate, ]
    uniq_mol_df$srr <- NULL
    uniq_mol_df$mol <- NULL
    dup_mol_df$srr <- NULL
    dup_mol_df$mol <- NULL
    
    subject_file <- paste(target_dir, paste0(label, ".dup_removed.bed"),
                          sep = "/")
    dup_file <- paste(target_dir, paste0(label, ".dup.bed"), sep = "/")
    write.table(uniq_mol_df, file = subject_file, sep = "\t",
                row.names = FALSE, col.names = FALSE, quote = FALSE)
    write.table(dup_mol_df, file = dup_file, sep = "\t",
                row.names = FALSE, col.names = FALSE, quote = FALSE)
    
    return(subject_file)
    
}
#' Visualize Single Molecule Footprint Patterns
#'
#' @description Generates footprint plots from NOME-seq data within specified genomic regions.
#' Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
#'
#' @param organism Organism code (default: "dmelanogaster")
#' @param model Biological model/system (default: "S2" cells)
#' @param condition Experimental condition (default: "WT")
#' @param genome_assembly Genome version (default: "dm6")
#' @param type Data type ("dSMF" = dual enzyme Single Molecule Footprinting)
#' @param chromosome Chromosome ID (e.g., "chr2L")
#' @param start Genomic start position (numeric/character)
#' @param end Genomic end position (numeric/character)
#' @param tr Track name for BigBed file resource (default: "fp_and_mvec")
#' @param label Plot title annotation
#' @param span_left Upstream window size from region (default: 150)
#' @param span_right Downstream window size from region (default: 150)
#' @param remove_dup Remove duplicate reads? (default: FALSE)
#' @param fp_cap Maximum footprint value for y-axis scaling (default: 50)
#' @param target_dir destination directory where outputs will be stored
#'
#' @return Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
#'
#' @details
#' This function retrieves and visualizes DNA accessibility patterns from single-molecule data:
#' - Integrates with UCSC-style track hubs via `tr` parameter
#' - Automatically handles coordinate conversion for dm6 genome
#' - Implements dynamic y-axis scaling using `fp_cap`
#'
#' @examples
#' # Basic usage with default parameters
#' plotFootprints()
#'
#' # Custom genomic region analysis
#' plotFootprints(
#'   chromosome = "chr2L", start = 480290, end = 480320, label = "peak229")
#'
#' @export
plotFootprints <- function(
        organism = "dmelanogaster", model = "S2",
        condition = "WT", genome_assembly = "dm6",
        type = "dSMF", chromosome = "chr2L",
        start = 480290, end = 480320,
        tr = "fp_and_mvec", label = "peak229",
        span_left = 150, span_right = 150, remove_dup = FALSE,
        fp_cap = 50, target_dir = "") {
    # Function implementation
}

plotFootprints <- function (organism = "dmelanogaster", model = "S2",
                            condition = "WT", genome_assembly = "dm6",
                            type = "dSMF", chromosome = "chr2L",
                            start = 480290, end = 480320,
                            tr = "fp_and_mvec", label = "peak229",
                            span_left = 150, span_right = 150,
                            remove_dup = FALSE, fp_cap = 50, target_dir = ""){
    
    # get JSON first
    #print (track)
    if (target_dir == ""){
        target_dir <- tempdir()
    }else if (!dir.exists(target_dir)){
        dir.create(target_dir, recursive = TRUE)
    }
    track_url <- getHubURL(organism = organism, model = model,
                           condition = condition, type = type,
                           genome_assembly = genome_assembly, tr = tr)
    #print(track_url)
    json_file <- downloadJson(track_url = track_url, chromosome = chromosome,
                              assembly = genome_assembly, st = start,
                              en = end, label = label, tr = tr, 
                              target_dir = target_dir)
    if (is.na(json_file)){
        print ("Download from UCSC REST API failed!")
        return (NA)
    }else {
    
        tmp_file <- JSON_to_Bed(json_file = json_file, label = label, tr = tr,
                                target_dir = target_dir)
        subject_file <- NA
        if (remove_dup == TRUE){
            subject_file <- remove_duplicate_molecules(fp_file = tmp_file,
                                                       label = label, target_dir = target_dir)
        }else{
            subject_file <- tmp_file
        }
        query_file <- prepareQueryFile(chromosome = chromosome,
                                       start = start, end = end, 
                                       label = label, target_dir = target_dir)
        
        overlap_df <- intersectQueryandSubject(query_file = query_file,
                                               subject_file = subject_file)
        # successful execution of this function will ensure that `overlap` file is
        # generated
        # get the second last column of the overlap_df and parse it using "|" as
        # delimiter. Example:
        # SRR3133329.41244179_41244179/1_adjacent`99~147|.131F52.77F35.5|.19h.33z.30h.14h.9z.20Z.4z.47H.3X.4H.Z.8Z.H.5Z.8X.9Z.18H.9Z.18x.16H.4
        # 2nd field is footprint, 3rd field is methylation vector
        fp_and_mvec_info <- overlap_df[, (length(overlap_df) - 1)]
        read_details <- unlist (lapply(fp_and_mvec_info,
                                       function (x) {
                                           yt = unlist(strsplit(x, split = "\\|")
                                           )[1] }))
        fp_vec <- unlist (lapply(fp_and_mvec_info,
                                 function (x) {
                                     yt = unlist(strsplit(x, split = "\\|")
                                     )[2] }))
        m_vec <- unlist (lapply(fp_and_mvec_info,
                                function (x) {
                                    yt = unlist(strsplit(x, split = "\\|"))[3] }))
        expanded_fp <- unlist(lapply(fp_vec, expand_cigar_string))
        expanded_m_vec <- unlist (lapply(m_vec, expand_cigar_string))
        combined <- data.frame (expanded_m_vec = expanded_m_vec,
                                expanded_fp = expanded_fp)
        with_edges <- unlist (apply(combined, 1,
                                    function(x){
                                        add_footprints_on_edges(x[1], x[2])} ))
        processed_df <- overlap_df[, c(1,2,3,4,5,6)]
        processed_df$read_details <- read_details
        processed_df$score <- 1.0
        processed_df$strand <- "."
        processed_df$expanded_footprint <- with_edges
        processed_df$expanded_m_vec <- expanded_m_vec
        length_and_read_info_df <- writeBindingStatesFiles (
            processed_df = processed_df,
            label = label,fp_cap = fp_cap,
            span_left = span_left, span_right = span_right,
            target_dir = target_dir)
        ordered_by_length <- length_and_read_info_df[with (length_and_read_info_df,
                                                           order(binding_state_vec,
                                                                 flag_vec,
                                                                 abs_start_vec)),]
        
        writeIntermediateFiles(ordered_by_length = ordered_by_length,
                               label = label, target_dir = target_dir)
        
        plot_title = paste0(organism, " ", model, " ", condition)
        x_label <- paste0(label, " (", genome_assembly, " ", 
                         chromosome, ":", start, "-", end, ")")
        pdf_file_path <- savePlotSMForDSMF(label = label, span_left = span_left, 
                                          span_right = span_right, plot_title = plot_title,
                                          x_label = x_label, target_dir = target_dir)
        #removing the intermediate files:
        deleteIntermediates(label = label, target_dir = target_dir)
        return (pdf_file_path) 
    }
}


#' Visualize Single Molecule Footprint Patterns using Local BigBed file
#'
#' @description Generates footprint plots from SMF/dSMF data within specified genomic regions.
#' Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
#'
#' @param bigBed BigBed file path (e.g., "demo.bb")
#' @param organism Organism code (default: "dmelanogaster")
#' @param model Biological model/system (default: "S2" cells)
#' @param condition Experimental condition (default: "WT")
#' @param genome_assembly Genome version (default: "dm6")
#' @param chromosome Chromosome ID (e.g., "chr2L")
#' @param start Genomic start position (numeric/character)
#' @param end Genomic end position (numeric/character)
#' @param label Plot title annotation
#' @param span_left Upstream window size from region (default: 150)
#' @param span_right Downstream window size from region (default: 150)
#' @param remove_dup Remove duplicate reads? (default: FALSE)
#' @param fp_cap Maximum footprint value for y-axis scaling (default: 50)
#' @param target_dir destination directory where outputs will be stored
#'
#' @return Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
#'
#' @details
#' This function uses local SMF/dSMF bigBed file and plot heatmap
#'
#'
#' @examples
#' # Basic usage with default parameters
#' plotFootprintsUsingLocalBigBed()
#'
#' # Custom genomic region analysis
#' plotFootprintsUsingLocalBigBed(
#'   bigBed = "inst/extdata/demo.bb", organism = "dmelanogaster",
#'   model = "S2", condition = "WT", genome_assembly = "dm3",
#'   chromosome = "chr2L", start = 480290, end = 480320, label = "peak229")
#'
#' @export
plotFootprintsUsingLocalBigBed <- function(
        bigBed = "inst/extdata/demo.bb", organism = "dmelanogaster", 
        model = "S2", condition = "WT", genome_assembly = "dm3",
        chromosome = "chr2L",start = 480290, end = 480320,
        label = "peak229", span_left = 150, span_right = 150,
        remove_dup = FALSE,fp_cap = 50, target_dir = "") {
    # Function implementation
}


plotFootprintsUsingLocalBigBed <- function (
        bigBed = "", organism = "dmelanogaster",
        model = "S2", condition = "WT", genome_assembly = "dm3",
        chromosome = "chr2L",start = 480290, end = 480320,
        label = "peak229", span_left = 150, span_right = 150,
        remove_dup = FALSE,fp_cap = 50, target_dir = "") {
    if (bigBed == "") {
        message ("'bigBed' arugment is empty. bigBed file file path requied\n")
        return ("bigBed file path")
    }else if (!file.exists(bigBed)){
        message ("bigBed file path requied\n")
        return ("bigBed file path")
    }
    if (target_dir == ""){
        target_dir <- tempdir()
    }else if (!dir.exists(target_dir)){
        dir.create(target_dir, recursive = TRUE)
    }
    query_file <- prepareQueryFile(chromosome = chromosome,
                                   start = start, end = end, 
                                   label = label, target_dir = target_dir)
    
    overlap_df <- overlapUsingBigBed(bigbed_file = bigBed,
                                     query_file = query_file)
    # successful execution of this function will ensure that `overlap` file is
    # generated
    # get the second last column of the overlap_df and parse it using "|" as
    # delimiter. Example:
    # SRR3133329.41244179_41244179/1_adjacent`99~147|.131F52.77F35.5|.19h.33z.30h.14h.9z.20Z.4z.47H.3X.4H.Z.8Z.H.5Z.8X.9Z.18H.9Z.18x.16H.4
    # 2nd field is footprint, 3rd field is methylation vector
    fp_and_mvec_info <- paste(overlap_df$name, overlap_df$field8, sep = "|")
    read_details <- unlist (lapply(fp_and_mvec_info,
                                   function (x) {
                                       yt = unlist(strsplit(x, split = "\\|")
                                       )[1] }))
    fp_vec <- unlist (lapply(fp_and_mvec_info,
                             function (x) {
                                 yt = unlist(strsplit(x, split = "\\|")
                                 )[2] }))
    m_vec <- unlist (lapply(fp_and_mvec_info,
                            function (x) {
                                yt = unlist(strsplit(x, split = "\\|"))[3] }))
    expanded_fp <- unlist(lapply(fp_vec, expand_cigar_string))
    expanded_m_vec <- unlist (lapply(m_vec, expand_cigar_string))
    combined <- data.frame (expanded_m_vec = expanded_m_vec,
                            expanded_fp = expanded_fp)
    with_edges <- unlist (apply(combined, 1,
                                function(x){
                                    add_footprints_on_edges(x[1], x[2])} ))
    processed_df <- overlap_df[, c(1,2,3,4,5,6)]
    #print (head (processed_df))
    processed_df$read_details <- read_details
    processed_df$score <- 1.0
    processed_df$strand <- "."
    processed_df$expanded_footprint <- with_edges
    processed_df$expanded_m_vec <- expanded_m_vec
    length_and_read_info_df <- writeBindingStatesFiles(
        processed_df = processed_df,
        label = label,fp_cap = fp_cap,
        span_left = span_left, span_right = span_right, 
        target_dir = target_dir)
    ordered_by_length <- length_and_read_info_df[with (length_and_read_info_df,
                                                       order(binding_state_vec,
                                                             flag_vec,
                                                             abs_start_vec)),]
    
    writeIntermediateFiles(ordered_by_length = ordered_by_length,
                           label = label, target_dir = target_dir)
    
    plot_title <- paste0(organism, " ", model, " ", condition)
    x_label <- paste0(label, " (", genome_assembly, " ", 
                     chromosome, ":", start, "-", end, ")")
    savePlotSMForDSMF(label = label, span_left = span_left, 
                      span_right = span_right, plot_title = plot_title, 
                      target_dir = target_dir)
    #removing the intermediate files:
    deleteIntermediates(label = label, target_dir = target_dir)
}



#' Discover Available Single Molecule Data Tracks
#'
#' @description Retrieves track metadata from a centralized Google Sheet containing
#' organism-specific single-molecule datasets and experimental conditions.
#'
#'
#' @return A tibble containing track metadata with columns:
#' \itemize{
#'   \item organism: Species identifier (e.g. "dmelanogaster")
#'   \item genome_assembly: Reference genome version
#'   \item condition: Experimental condition
#'   \item model: Biological model/system
#'   \item track_name: Identifier for `tr` parameter in `plotFootprints`
#'   \item data_type: NOME-seq protocol variant
#'   \item bigbed_url: Cloud-hosted data location
#' }
#'
#' @examples
#' # List all available tracks from default repository
#' listTracks()
#'
#'
#' @seealso
#' `plotFootprints()`: Use track names from this list to visualize specific datasets
#'
#' @export
listTracks <- function() {
    print(hubs)
}


listTracks <- function(){
    
    print(hubs)
}

############################## Nanopore ########################################


#' Visualize Single Molecule Footprint Patterns
#'
#' @description Generates footprint plots from NOME-seq data within specified genomic regions.
#' Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
#'
#' @param organism Organism code (default: "scerevisiae")
#' @param model Biological model/system (default: "BY4741 strain")
#' @param condition Experimental condition (default: "WT")
#' @param genome_assembly Genome version (default: "sacCer3")
#' @param type Data type ("Nanopore" = dual enzyme Single Molecule Footprinting)
#' @param chromosome Chromosome ID (e.g., "chrIII")
#' @param start Genomic start position (numeric/character)
#' @param end Genomic end position (numeric/character)
#' @param tr Track name for BigBed file resource (default: "nanopore_meth_calls")
#' @param label Plot title annotation (default: "smac_seq")
#' @param span_left Upstream window size from region (default: 1000)
#' @param span_right Downstream window size from region (default: 1000)
#' @param stride sliding window used for singal aggregation 
#' @param target_dir destination directory where outputs will be stored
#'
#' @return Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
#'
#' @details
#' This function retrieves and visualizes DNA accessibility patterns from single-molecule data:
#' - Integrates with UCSC-style track hubs via `tr` parameter
#' - Automatically handles coordinate conversion for dm6 genome
#' - Implements dynamic y-axis scaling using `fp_cap`
#'
#' @examples
#' # Basic usage with default parameters
#' plotMethylationCallsNanopore()
#'
#' # Custom genomic region analysis
#'
#' plotMethylationCallsNanopore (
#'         organism = "scerevisiae", model = "BY4741 strain",
#'         condition = "WT", genome_assembly = "sacCer3",
#'         type = "SMF", chromosome = "chrIII",
#'         start = 114300, end = 114600,
#'         tr = "nanopore_meth_calls", label = "smac_seq",
#'         span_left = 1000, span_right = 1000, stride = 5, target_dir = "")


#' @export
plotMethylationCallsNanopore <- function(
        organism = "scerevisiae", model = "BY4741 strain",
        condition = "WT", genome_assembly = "sacCer3",
        type = "SMF", chromosome = "chrIII",
        start = 114300, end = 114600,
        tr = "nanopore_meth_calls", label = "smac_seq",
        span_left = 1000, span_right = 1000, stride = 5, target_dir = "") {
    # Function implementation
}


plotMethylationCallsNanopore <- function(
        organism = "scerevisiae", model = "BY4741 strain",
        condition = "WT", genome_assembly = "sacCer3",
        type = "SMF", chromosome = "chrIII",
        start = 114300, end = 114600,
        tr = "nanopore_meth_calls", label = "smac_seq",
        span_left = 1000, span_right = 1000, stride = 5, target_dir = "") {
    
    if (target_dir == ""){
        target_dir <- tempdir()
    }else if (!dir.exists(target_dir)){
        dir.create(target_dir, recursive = TRUE)
    }
    
    track_url <- getHubURL(organism = organism, model = model,
                           condition = condition, type = type,
                           genome_assembly = genome_assembly, tr = tr)
    #print(track_url)
    json_file <- downloadJson(track_url = track_url, chromosome = chromosome,
                              assembly = genome_assembly, st = start,
                              en = end, label = label, tr = tr, 
                              target_dir = target_dir)
    if (is.na(json_file)){
        print("JSON download from UCSC REST API failed")
        return (NA)
    } else {
        subject_file <- JSON_to_Bed_for_Nanopore(json_file = json_file,
                                                 label = label, tr = tr,
                                                 target_dir = target_dir)
        query_file <- prepareQueryFile(chromosome = chromosome,
                                       start = start, end = end, 
                                       label = label, target_dir = target_dir)
        
        overlap_df <- intersectQueryandSubject(query_file = query_file,
                                               subject_file = subject_file)
        
        overlap_df_for_plot <- overlap_df[, c(1, 2, 3,4,5,6,7,8)]
        read_id <- unlist (lapply(overlap_df$name,
                                  function (x) {
                                      yt = unlist(strsplit(x, split = "\\|")
                                      )[1] }))
        methylation_call <- unlist (lapply(overlap_df$name,
                                           function (x) {
                                               yt = unlist(strsplit(x, split = "\\|")
                                               )[2] }))
        overlap_df_for_plot$name <- read_id
        overlap_df_for_plot$score <- overlap_df$score
        overlap_df_for_plot$methylation_call <- methylation_call
        
        write.table(overlap_df_for_plot, 
                    file = paste(target_dir, paste0(label, ".intersect.bed"), 
                                 sep = "/"),
                    sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
        data_to_plot_and_strand_map_df = generatePlotMatrix(overlap_df_for_plot,
                                                            span_left = span_left,
                                                            span_right = span_right)
        data_to_plot <- data_to_plot_and_strand_map_df$out_mat
        strand_map_df <- data_to_plot_and_strand_map_df$strand_map_df
        pos_strand_reads <- names (strand_map_df[strand_map_df$strand == "+", ])
        neg_strand_reads <- names (strand_map_df[strand_map_df$strand == "-", ])
        
        center <- as.integer(dim(data_to_plot)[2]/2)
        half_width <- as.integer((as.integer(end) - as.integer(start))/(2*stride) )
        l_index <- center - half_width
        r_index <- center + half_width
        sub_df <- data_to_plot[, seq (l_index, r_index)]
        sum_by_row <- apply(sub_df, 1, sum)
        tmp <- strand_map_df
        
        ordered_by_methylation <- sum_by_row[order(sum_by_row)]
        tmp$cnt <- ordered_by_methylation[row.names(strand_map_df)]
        ordered_tmp <- tmp[order(factor (tmp$strand, levels = c("-", "+")), tmp$cnt),]
        data_to_plot <- data_to_plot[row.names(ordered_tmp),]
        write.table (table (factor(strand_map_df$strand, levels = c("-", "+"))),
                     file = paste (target_dir, 
                                   paste0(label, ".strand_wise_count.tsv"), sep = "/"),
                     sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
        write.table (data_to_plot, file = paste(target_dir, 
                                                paste0(label, ".nanopore_methylation.tsv"), sep = "/"),
                     sep = "\t", row.names = TRUE, col.names = FALSE, quote = FALSE)
        plot_title <- paste0(organism, " ", model, " ", condition)
        x_label <- paste0(label, " (", genome_assembly, " ", 
                         chromosome, ":", start, "-", end, ")")
        savePlotNanopore(label = label, plot_title = plot_title, x_label = x_label,
                     target_dir = target_dir)
    }
}





#' Visualize aggregate methylation calls from ONT sequencing data
#'
#' @description Generates heatmap of methylation calls from likes of SMAC-seq datasets.
#' currently has data from Yeast (sacCer3)
#'
#' @param bigBed BigBed file path (e.g., "demo.bb")
#' @param chromosome Chromosome ID (e.g., "chr2L")
#' @param start Genomic start position (numeric/character)
#' @param end Genomic end position (numeric/character)
#' @param label Plot title annotation
#' @param span_left Upstream window size from region (default: 150)
#' @param span_right Downstream window size from region (default: 150)
#' @param remove_dup Remove duplicate reads? (default: FALSE)
#' @param stride a window size used for averaging the methylation call values
#' @param target_dir destination directory where outputs will be stored
#'
#' @return Saves a methylation calls (binary) heatmap in pdf, png, and eps file formats.
#'
#' @details
#' This function uses local SMF/dSMF bigBed file and plot heatmap
#'
#'
#'
#' @export
plotMethylationCallsNanoporeUsingLocalBigBed <- function(
        bigBed = "", 
        chromosome = "chrIII",start = 114300, end = 114600,
        label = "smac_seq", span_left = 1000, span_right = 1000,
        remove_dup = FALSE, stride = 5, target_dir = "") {
    # Function implementation
}


plotMethylationCallsNanoporeUsingLocalBigBed <- function (
        bigBed = "",
        chromosome = "chrIII",start = 114300, end = 114600,
        label = "smac_seq", span_left = 1000, span_right = 1000,
        remove_dup = FALSE, stride = 5, target_dir = "") {
    
    if (bigBed == "") {
        message ("'bigBed' arugment is empty. bigBed file file path requied\n")
        return ("bigBed file path")
    }else if (!file.exists(bigBed)){
        message ("bigBed file path requied\n")
        return ("bigBed file path")
    }
    if (target_dir == ""){
        target_dir <- tempdir()
    }else if (!dir.exists(target_dir)){
        dir.create(target_dir, recursive = TRUE)
    }
    
    
    query_file <- prepareQueryFile(chromosome = chromosome,
                                   start = start, end = end,
                                   label = label, target_dir = target_dir)
    
    overlap_df <- overlapUsingBigBed(bigbed_file = bigBed,
                                     query_file = query_file)
    
    write.table(overlap_df, file = paste(target_dir, 
                                         paste0(label, ".intersect.bed"), sep = "/"),
                sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
    data_to_plot_and_strand_map_df = generatePlotMatrix(overlap_df,
                                                        span_left = span_left,
                                                        span_right = span_right)
    data_to_plot <- data_to_plot_and_strand_map_df$out_mat
    strand_map_df <- data_to_plot_and_strand_map_df$strand_map_df
    pos_strand_reads <- names (strand_map_df[strand_map_df$strand == "+", ])
    neg_strand_reads <- names (strand_map_df[strand_map_df$strand == "-", ])
    
    center <- as.integer(dim(data_to_plot)[2]/2)
    half_width <- as.integer((as.integer(end) - as.integer(start))/(2*stride) )
    l_index <- center - half_width
    r_index <- center + half_width
    sub_df <- data_to_plot[, seq (l_index, r_index)]
    sum_by_row <- apply(sub_df, 1, sum)
    tmp <- strand_map_df
    
    ordered_by_methylation <- sum_by_row[order(sum_by_row)]
    tmp$cnt <- ordered_by_methylation[row.names(strand_map_df)]
    ordered_tmp <- tmp[order(factor (tmp$strand, levels = c("-", "+")), tmp$cnt),]
    data_to_plot <- data_to_plot[row.names(ordered_tmp),]
    write.table (table (factor(strand_map_df$strand, levels = c("-", "+"))),
                 file = paste(target_dir, paste0(label, ".strand_wise_count.tsv"),
                              sep = "/"),
                 sep = "\t", row.names = FALSE, col.names = FALSE, quote = FALSE)
    write.table (data_to_plot, file = paste(target_dir, paste0(label, 
                                                               ".nanopore_methylation.tsv"), sep = "/"),
                 sep = "\t", row.names = TRUE, col.names = FALSE, quote = FALSE)
    savePlotNanopore(label = label, target_dir = target_dir)
}

generatePlotMatrix <- function (methylation_call_df, span_left = 1000,
                                span_right = 1000, stride = 5){
    # define a zero matrix to fill
    n_molecules <- dim(methylation_call_df)[1]
    roi_start <- methylation_call_df[1, 2]
    roi_end <- methylation_call_df[1, 3]
    total_columns <- (span_left + span_right + (roi_end - roi_start))/stride + 1
    out_mat <- matrix (0L, nrow = 0, ncol = total_columns)
    read_name_vec <- c ()
    strand_map_df <- data.frame("strand" = c())
    strand_vec <- c()
    #methylation_count_df = data.frame("read_id" = )
    for (i in seq (1, n_molecules)){
        # complete vector for a read
        spanned_vector <- c()
        read_start <- methylation_call_df[i, 5]
        read_end <- methylation_call_df[i, 6]
        
        status_on_read <- as.numeric(unlist(
            strsplit(methylation_call_df[i, 11], split = ",")))
        total_length = length(status_on_read)
        abs_start_for_plot <- roi_start - span_left
        abs_end_for_plot <- roi_end + span_right
        read_name_vec <- c(read_name_vec, paste0(i,"_", methylation_call_df[i, 9]))
        strand_vec <- c(strand_vec, as.character(methylation_call_df[i, 8]))
        approximate_start_offset <- (abs_start_for_plot - read_start)/stride
        approximate_start_offset <- as.integer(approximate_start_offset)
        approximate_end_offset <- approximate_start_offset + (abs_end_for_plot - abs_start_for_plot)/stride
        approximate_end_offset <- as.integer(approximate_end_offset)
        
        for (j in seq (approximate_start_offset, approximate_end_offset)){
            if (j < 1 || j > total_length){
                spanned_vector <- c(spanned_vector, -1)
            } else {
                spanned_vector <- c(spanned_vector , status_on_read[j])
            }
        }
        out_mat <- rbind (out_mat, spanned_vector)
        
    }
    row.names (out_mat) <- read_name_vec
    strand_map_df <- data.frame("strand" = strand_vec)
    row.names (strand_map_df) <- read_name_vec
    return (list (out_mat = out_mat, strand_map_df = strand_map_df))
}

deleteIntermediates <- function (label = "peak229", target_dir = ""){
    label = paste(target_dir, label, sep = "/")
    if (file.exists(paste0(label, "_assigned_states.tsv"))){
        file.remove(paste0(label, "_assigned_states.tsv"))
    }
    if (file.exists(paste0(label, "_labelled_and_ordered.tsv"))){
        file.remove(paste0(label, "_labelled_and_ordered.tsv"))
    }
    if (file.exists(paste0(label, "_verbose.tsv"))){
        file.remove(paste0(label, "_verbose.tsv"))
    }
    if (file.exists(paste0(label, ".all_fp.bed"))){
        file.remove(paste0(label, ".all_fp.bed"))
    }
    file.remove(paste0(label, ".bed"))
    if (file.exists(paste0(label, ".json"))){
        file.remove(paste0(label, ".json"))
    }
    
    #file.remove(paste0(label, ".num.fp.tsv"))
    #file.remove(paste0(label, ".num.mvec.tsv"))
}

#' Visualize Single Molecule Footprint Patterns with Ideogram and Gene Tracks
#'
#' @description Generates Gviz-compatible R code that puts SMF footprints below ideogram and genetracks. This call assumes that you have already ran `plotFootprints` function. 
#' Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
#'
#' @param organism Organism code (default: "dmelanogaster")
#' @param model Biological model/system (default: "S2" cells)
#' @param condition Experimental condition (default: "WT")
#' @param genome_assembly Genome version (default: "dm6")
#' @param type Data type ("dSMF" = dual enzyme Single Molecule Footprinting)
#' @param chromosome Chromosome ID (e.g., "chr2L")
#' @param start Genomic start position (numeric/character)
#' @param end Genomic end position (numeric/character)
#' @param tr Track name for BigBed file resource (default: "fp_and_mvec")
#' @param label Plot title annotation
#' @param span_left Upstream window size from region (default: 150)
#' @param span_right Downstream window size from region (default: 150)
#' @param remove_dup Remove duplicate reads? (default: FALSE)
#' @param fp_cap Maximum footprint value for y-axis scaling (default: 50)
#' @param gviz_left left zoom (bases) from the start
#' @param gviz_right right zoom (bases) from the end
#' @param target_dir destination directory (must be the same used in `plotFootprints` function)
#'
#' @return Saves a heatmap in pdf, png, and eps file formats.
#'
#' @details
#' This function generates a R code running which one can get ideogram, genetracks and SMF heatmap altogether in one plot.
#'
#' @examples
#' # Basic usage with default parameters
#' generateGvizCodeforSMF(organism = "mmusculus", model = "16cell", 
#'                          condition = "WT", genome_assembly = "mm10",
#'                          type = "SMF", chromosome = "chr1",start = 191718250,
#'                          end = 191718280, tr = "16cell", label = "tss",
#'                          fp_cap = 50, remove_dup = FALSE, gviz_left = 500,
#'                          gviz_right = 500, target_dir = "")
#'                          
#'
#' @export
generateGvizCodeforSMF <- function (organism = "mmusculus", model = "16cell", 
                                    condition = "WT", genome_assembly = "mm10",
                                    type = "SMF", chromosome = "chr1", start = 191718250,
                                    end = 191718280, tr = "16cell", label = "tss",
                                    fp_cap = 50, remove_dup = FALSE, gviz_left = 500, 
                                    gviz_right = 500, target_dir = "") {
    # Function implementation
}

generateGvizCodeforSMF <- function (organism = "demlanogaster", model = "S2",
                                    condition = "WT", genome_assembly = "dm6",
                                    type = "dSMF", chromosome = "chr2L",
                                    start = 480290, end = 480320,
                                    tr = "fp_and_mvec", label = "peak229",
                                    span_left = 150, span_right = 150, remove_dup = FALSE,
                                    fp_cap = 50, gviz_left = 1000, gviz_right = 1000, target_dir = ""){
    
    fp_file = paste (target_dir, paste0(label, ".num.fp.tsv"), sep = "/")
    occ_file = paste (target_dir, paste0("plots/", label, ".states.tsv"), 
                      sep = "/")
    
    fp_file_flag = file.exists(fp_file)
    occ_file_flag = file.exists(occ_file)
    if (fp_file_flag && occ_file_flag){
        
        # get number of valid states and their count
        occ_dt = read.table(occ_file, sep = "\t", header = TRUE,
                            stringsAsFactors = FALSE)
        num_states = dim(occ_dt)[1]
        total_molecules = sum(occ_dt$count)
        
        gviz_code_file = paste(target_dir, paste0(label, ".gviz.R"), sep = "/")
        libs_and_options = c("library(biomaRt)", "library(Gviz)",
                             "options(ucscChromosomeNames=TRUE)")
        cat (libs_and_options, sep = "\n", file = gviz_code_file)
        
        chrom = paste0("chrom = ", '"', chromosome, '"')
        genome = paste0("genome = ", '"', genome_assembly, '"')
        
        
        cat (paste0("locus = ", as.integer((start + end)/2)),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("start = ", start),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("gviz_left = ", gviz_left),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("gviz_right = ", gviz_right),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("span_left = ", span_left),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("span_right = ", span_right),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat ("starts <- seq (locus - span_left, locus + span_right, by = 1)",
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat ("ends <- starts + 1",
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (chrom, genome, file = gviz_code_file, sep = "\n", append = TRUE)
        ideogram = paste0("itrack = IdeogramTrack(genome = ", '"',
                          genome_assembly,'"',
                          ", chromosome = ", '"',  chromosome, '"',")" )
        cat (ideogram, file = gviz_code_file, sep = "\n", append = TRUE)
        
        mart_str = paste0 ("mart <- useMart('ensembl', dataset = '",
                           organism, "_gene_ensembl'",
                           ", host = 'https://nov2020.archive.ensembl.org/')")
        
        cat (mart_str, file = gviz_code_file, sep = "\n", append = TRUE)
        
        cat (paste0("genes <- BiomartGeneRegionTrack(
        genome = genome,
        biomart = mart,
        chromosome = chrom,
        start = start - ", gviz_left,
                    ", end = start + ", gviz_right,
                    ", name = 'Gene Model')"),
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat ("displayPars(genes) = list(transcriptAnnotation='symbol',
    showExonId=FALSE)",
             file = gviz_code_file, sep = "\n", append = TRUE)
        fp_file = paste0(label, ".num.fp.tsv")
        cat (paste0("real_data = read.table('", fp_file, "'",
                    ", sep = '\\t', header = FALSE, stringsAsFactors = FALSE,
                comment.char = '%')"),
             file = gviz_code_file, sep = "\n", append = TRUE)
        
        cat (paste("row.names(real_data) = real_data$V1",
                   "real_data$V1 = NULL",
                   "real_data = as.matrix(real_data)",
                   "df_to_list = list()", sep = "\n"),
             file = gviz_code_file, sep = "\n", append = TRUE)
        prev = 1
        cat ("axisTrack <- GenomeAxisTrack()",
             file = gviz_code_file, sep = "\n", append = TRUE)
        
        cat ("bstarts <- seq (locus - span_left - 20, locus + span_right, by = 1)
        bends <- bstarts + 1
        gr = GRanges(seqnames = chrom,
                     ranges = IRanges(start = bstarts, end = bends),
                     score = rep (-1, 321))
        red_line <- DataTrack(
            range = gr,
            type = 'heatmap',        # heatmap mode
            name = '',
            gradient = c('red', 'white', 'blue'),  # color scale
            ylim = c(-1,0),
            showAxis = FALSE,
            background.title = 'white')",
             file = gviz_code_file, sep = "\n", append = TRUE)
        
        # set track sizes :
        # ideogram : fixed,10% of the plot height
        # axisTrack: fixed, 5% of the plot height
        # geneTrack: fixed, 25% of the plot height
        # rest is SMF plots
        all_tracks = "c(axisTrack, genes"
        track_sizes = "c(0.1, 0.05, 0.25"
        line_counter = 0
        heatmap_height = 0.4 # 40% of the plot height
        per_line_width = round (heatmap_height/total_molecules, 6)
        for (i in seq(num_states)){
            state_label = occ_dt[i, "state_label"]
            mol_cnt = occ_dt[i, "count"]
            current = prev + mol_cnt - 1
            
            cat (paste0("df_to_list[[", "'", state_label,"'", "]] = ",
                        "lapply(seq(", prev, ",", current, "), ", "function(x) {
        gr = GRanges(seqnames = chrom,
                     ranges = IRanges(start = starts, end = ends),
                     score = unname(real_data[x,]))
        heatmapTrack <- DataTrack(
            range = gr,
            type = 'heatmap',
            name = '',
            #gradient = c('grey', 'white', '#41b6c4'),  # color scale
            gradient = c('grey', 'white', '#1f78b4'),  # color scale
            ylim = c(-1, 1),
            showAxis = FALSE,
            background.title = 'white')
        return (heatmapTrack)})"),
                 file = gviz_code_file, sep = "\n", append = TRUE)
            prev = current + 1
            
            track_sizes = paste0(track_sizes, ", rep (",
                                 per_line_width, ", ", mol_cnt, ")")
            all_tracks = paste0(all_tracks, ",
                                df_to_list[['", state_label, "']]")
            if (line_counter < num_states - 1){ # if 3 states then counter will run for 0 and 1
                track_sizes = paste0(track_sizes, ", ", per_line_width/2)
                line_counter = line_counter + 1
                all_tracks = paste0(all_tracks, ", red_line")
            }
        }
        
        all_tracks = paste0(all_tracks, ")")
        track_sizes = paste0(track_sizes, ")")
        # highLightTracks
        
        cat (paste0("hl_tracks <- HighlightTrack (trackList = ", all_tracks,
                    ", genome = '", genome_assembly, "'",
                    ", chromosome = '", chromosome, "'",
                    ", col = 'red', fill = 'transparent', start = c (",
                    start, ")", ", width = ", end - start, ", name = 'RoI' )")
             , file = gviz_code_file, sep = "\n", append = TRUE)
        cat ("\n", file = gviz_code_file, sep = " ", append = TRUE)
        
        cat ("displayPars(hl_tracks) = list (inBackground = FALSE, col = 'red')",
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat ("\n", file = gviz_code_file, sep = " ", append = TRUE)
        cat (paste0("pdf('plots/", label, ".gviz.pdf'"), ",", " height = 10, width = 8)",
             file = gviz_code_file, sep = " ", append = TRUE)
        cat ("\n", file = gviz_code_file, sep = "\n", append = TRUE)
        
        cat (paste0("plotTracks(c(itrack, hl_tracks)",
                    ", chromosome = chrom,
            from = locus - gviz_left,  # zoom start
            to = locus + gviz_right,    # zoom end
            background.title = 'white',
            showColorBar = FALSE,
            showAxis = FALSE, showLabel = FALSE,
            sizes =", track_sizes, ")"), file = gviz_code_file,
             sep = "\n", append = TRUE)
        
        cat ("dev.off()",
             file = gviz_code_file, sep = "\n", append = TRUE)
        cat (paste0("A R code file ", gviz_code_file, 
                    " is written. Please run the command: Rscript ",
                    gviz_code_file, " to place the heatmap on gene track!\n"))
        
    }else{
        cat (paste0("Both files", fp_file, " ", occ_file, " ", 
                    "must exist to generate the code\n"))
        return ("Please call plotFootprints function before you run this function")
    }
    
}

savePlotNanopore <- function (label = "smac_seq", span_left = 1000,
                              span_right = 1000, stride = 5, 
                              plot_title = "scerevisiae BY4741 strain",
                              x_label = "smac_seq (sacCer3 chrIII:114300-114600)",
                              target_dir = ""){
    data_to_plot <- read.table (paste(target_dir, 
                                     paste0(label, ".nanopore_methylation.tsv"),
                                     sep = "/"),
                               sep = "\t", header = FALSE, stringsAsFactors = FALSE,
                               row.names = 1)
    strand_counts_df <- read.table(paste(target_dir, 
                                        paste0(label, ".strand_wise_count.tsv"),
                                        sep = "/"),
                                  sep = "\t", header = FALSE, stringsAsFactors = FALSE)
    row.names(strand_counts_df) <- strand_counts_df$V1
    mid_point_minus_strand <- strand_counts_df["-", "V2"]/2
    mid_point_plus_strand <- strand_counts_df["-", "V2"] + strand_counts_df["+", "V2"]/2
    
    x_width <- dim(data_to_plot)[2]
    total_molecules <- dim(data_to_plot)[1]
    main_dir <- target_dir
    if (!dir.exists(main_dir)){
        dir.create(main_dir, recursive = TRUE)
    }
    plot_dir <- paste(main_dir, "plots", sep = "/")
    if (!dir.exists(plot_dir)){
        dir.create(plot_dir, recursive = TRUE)
    }
    
    if (nrow(data_to_plot) > 15){
        
        pdf (file.path(plot_dir, paste0(label, ".heatmap.pdf")),
             height = 5, width = 10, bg = "white")
        dev.control("enable")
        
        par(mgp=c(1.5,0.25,0), cex = 1)
        image(seq(1,ncol(data_to_plot)), seq(1,nrow(data_to_plot)), t(data_to_plot),
              axes = FALSE, useRaster = TRUE,
              oldstyle = FALSE, col = c("-1" = "#bdbdbd", "0" = "#FFFFFF",
                                        "1"  = "Red" , "2" = "#C7E9C0"),
              xlim = c(-30, x_width), xlab = paste0("           ", x_label),
              ylab = "", main = paste0("      ",
                                       plot_title))
        
        
        # Draw vertical red line +/- 15 bases from `0`
        left_line <- span_left/stride
        right_line <- x_width - (span_right/stride)
        segments(left_line , 0, left_line,
                 (total_molecules + 0.5), lwd = 0.5, col = "Blue")
        segments(right_line, 0, right_line,
                 (total_molecules + 0.5), lwd = 0.5, col = "Blue")
        segments(-30, strand_counts_df["-", "V2"],
                 x_width, strand_counts_df["-", "V2"], lwd = 0.5, col = "Blue")
        
        ticks_at <- seq(0, x_width, 100/stride)
        lab_at_ticks <- as.character((ticks_at - as.integer(x_width/2) )*stride)
        axis(1, ticks_at,
             lab_at_ticks,
             las = 2, cex.lab = 0.5, tck = -0.01, tick = FALSE)
        
        box(lwd=0.5)
        
        text (-15, mid_point_minus_strand, paste0(" - (n = ",
                                                  strand_counts_df["-", "V2"],
                                                  " )"), srt = 90, cex = 1)
        text (-15, mid_point_plus_strand, paste0(" + (n = ",
                                                 strand_counts_df["+", "V2"],
                                                 " )"), srt = 90, cex = 1)
        #saveToPDF(file.path(plot_dir, paste0(label, ".heatmap.pdf")),
        #          height = 5, width = 10)
        #saveToPNG(file.path(plot_dir, paste0(label, ".plot.png")),
        #          height = 5, width = 10, units = "in", res = 300)
        #saveToEPS(file.path(plot_dir, paste0(label, ".heatmap.eps")),
        #          height = 5, width = 10,
        #          horizontal = FALSE, paper = "special")
        dev.copy(postscript, file.path(plot_dir, paste0(label, ".heatmap.eps")),
                 height = 5, width = 10, 
                 horizontal = FALSE, paper = "special")
        dev.control("enable")
        
        dev.copy(png, file.path(plot_dir, paste0(label, ".plot.png")),
                 height = 5, width = 10, units = "in", res = 300)
        dev.off()
        dev.off()
        dev.off()
        message (paste0("Heatmap is saved in the file ", 
                    file.path(plot_dir, paste0(label, ".heatmap.pdf"))))
        message ("\n")
        
    }else {
        
        pdf (file.path(plot_dir, paste0(label, ".heatmap.pdf")),
             height = 6, width = 4.5, bg = "white")
        dev.control("enable")
        par(mgp=c(1.5,0.25,0), cex = 0.75)
        plot(c(0, 1), c(0, 1), ann = FALSE, bty = 'n', type = 'n',
             xaxt = 'n', yaxt = 'n');
        text(x = 0.5, y = 0.5, paste0("Only ", nrow (data_to_plot),
                                      " molecules, not enough for plotting"))
        
        dev.copy(postscript, file.path(plot_dir, paste0(label, ".heatmap.eps")),
                 height = 6, width = 4.5, 
                 horizontal = FALSE, paper = "special")
        dev.control("enable")
        
        dev.copy(png, file.path(plot_dir, paste0(label, ".plot.png")),
                 height = 6, width = 4.5, units = "in", res = 300)
        dev.off()
        dev.off()
        dev.off()
        message (paste0("Heatmap is saved in the file ", 
                    file.path(plot_dir, paste0(label, ".heatmap.pdf"))))
        message ("\n")
        
    }
    
}

bfc <- BiocFileCache::BiocFileCache()
retrieve_json <- function (track_url = "", assembly = "dm6",
                           chromosome = "chr2L", st = "480290",
                           en = "480320", label = "peak229",
                           tr = "fp_and_mvec", target_dir = ""){
    
    download_command = paste0(track_url, ";", "genome=", assembly,";",
                              "track=", tr, ";",
                              "chrom=", chromosome,";",
                              "start=", st,";", "end=", en)

    json_path <- tryCatch (
        {
            json_path <- bfcrpath (bfc, download_command)
        }, 
        error = function(e) {
            print (paste0("Download failed with error ", e))
            return (NA)
        },
        warning = function(w) {
            print (paste0("Please see the warning ", w))
            return (NA)
        }
    )
    return(json_path)
}

downloadJson <- function (track_url = "", assembly = "dm6",
                          chromosome = "chr2L", st = "",
                          en = "", label = "peak229",
                          tr = "fp_and_mvec", target_dir = ""){
    message ("Using UCSC API to get JSON dump from BigBed Track ...\n")
    #print (c(track_url, assembly, chromosome, st, en, label))
    json_name <- retrieve_json (track_url = track_url, assembly = assembly,
                                chromosome = chromosome, st = st, en = en,
                                label = label, tr = tr, target_dir = target_dir)
    return (json_name)
    
}

JSON_to_Bed <- function (json_file = "peak229.json", label = "peak229", 
                         tr = "fp_and_mvec", target_dir = "") {
    x <- fromJSON(json_file)
    flat_names <- names (x[[tr]])
    df_of_json = as.data.frame(x[[tr]], col.names = flat_names)
    
    output_file = file (paste(target_dir, paste0(label, ".all_fp.bed"), 
                              sep = "/"), "w")
    output_file_name = paste(target_dir, paste0(label, ".all_fp.bed"),
                             sep = "/")
    for (fp in seq_len(nrow(df_of_json))) {
        chrom <- df_of_json$chrom[fp]
        st <- df_of_json$chromStart[fp]
        en <- df_of_json$chromEnd[fp]
        fp_info <- df_of_json$name[fp]
        score <- df_of_json$score[fp]
        strand <- "+"
        m_vec <- df_of_json$field8[fp]
        cat (paste(chrom, st, en, paste(fp_info, m_vec, sep = "|"),
                  score, strand, sep = "\t"), file = output_file, append = TRUE)
        cat ("\n", file  = output_file, append = TRUE)
    }
    close(output_file)
    return (output_file_name)
}

JSON_to_Bed_for_Nanopore <- function (json_file = "smac_seq.json",
                                      label = "smac_seq",
                                      tr = "nanopore_meth_calls",
                                      target_dir = "") {
    x <- fromJSON(json_file)
    flat_names <- names (x[[tr]])
    df_of_json = as.data.frame(x[[tr]], col.names = flat_names)
    
    output_file = file (paste(target_dir, paste0(label, ".methylation_calls.bed"),
                              sep = "/"), "w")
    output_file_name = paste(target_dir, paste0(label, ".methylation_calls.bed"),
                             sep = "/")
    for (meth_call in seq_len(nrow(df_of_json))) {
        chrom <- df_of_json$chrom[meth_call]
        st <- df_of_json$chromStart[meth_call]
        en <- df_of_json$chromEnd[meth_call]
        read_id <- df_of_json$name[meth_call]
        score <- df_of_json$score[meth_call]
        strand <- df_of_json$strand[meth_call]
        m_vec <- df_of_json$field8[meth_call]
        
        cat (paste(chrom, st, en, paste(read_id, m_vec, sep = "|"),
                  score, strand, sep = "\t"),
            file = output_file, append = TRUE)
        cat ("\n", file  = output_file, append = TRUE)
    }
    close(output_file)
    return (output_file_name)
}



intersectQueryandSubject <- function(query_file = "peak229.bed",
                                     subject_file = "peak229.all_fp.bed",
                                     overlap = "peak229_overlap.bed") {
    q_obj <- import (query_file)
    s_obj <- import (subject_file)
    overlaps <- findOverlaps(q_obj, s_obj, minoverlap = width(q_obj),
                             select = "all")
    q_obj_to_write <- resize (q_obj[from(overlaps), ],
                              width(q_obj[from(overlaps), ]) + 1, fix = "end")
    q_df = as.data.frame(q_obj_to_write)
    sub_q_df <- q_df [, seq(3)]
    
    s_obj_to_write <- resize (s_obj[to(overlaps), ],
                              width (s_obj[to(overlaps), ]) + 1, fix = "end")
    s_df <- as.data.frame(s_obj_to_write)
    result_df <- cbind (sub_q_df, s_df)
    return (result_df)
    # now reading files again to prepare
    
}
prepareQueryFile <- function (chromosome = "chr2L",
                              start = 480290,
                              end = 480320,
                              label = "peak229", target_dir = ""){
    query_file <- paste(target_dir, paste0(label, ".bed"), sep = "/")
    cat(paste(chromosome, start, end, sep = "\t"),
         file = query_file, append = FALSE)
    cat("\n", file = query_file, append = TRUE)
    return (query_file)
}

overlapUsingBigBed <- function (
        bigbed_file = "inst/extdata/demo.bb",
        query_file = "peak229.bed"){
    q_obj <- import (query_file)
    s_obj <- import(bigbed_file, which = q_obj)
    overlaps <- findOverlaps(q_obj, s_obj, minoverlap = width(q_obj),
                             select = "all")
    q_obj_to_write <- resize (q_obj[from(overlaps), ],
                              width(q_obj[from(overlaps), ]) + 1, fix = "end")
    q_df <- as.data.frame(q_obj_to_write)
    sub_q_df <- q_df [, seq(3)]
    
    s_obj_to_write <- resize (s_obj[to(overlaps), ],
                              width (s_obj[to(overlaps), ]) + 1, fix = "end")
    s_df <- as.data.frame(s_obj_to_write)
    result_df <- cbind (sub_q_df, s_df)
    return (result_df)
    
}

---
title: "SMTrackR"
author: "Aashna Bansal, Himani Barmola, Shivam Yadav, Satyanarayan Rao"
date: "2025-06-12"
vignette: >
      %\VignetteIndexEntry{SMTrackR}
      %\VignetteEngine{knitr::rmarkdown}
      \usepackage[utf8]{inputenc}
output: 
  BiocStyle::html_document:
    toc: true
    toc_depth: 2

---

```{r setup, include=FALSE}
knitr::opts_chunk$set(echo = TRUE)
options(warn=-1)
```

## Introduction
Single-molecule assays like NOMe-seq, and dSMF are superior to DNase-seq and ATAC-seq as they do not cleave DNA (see schematics below). Thus, they enable quantification of all three i.e., protein-free, Transcription Factor-bound and histone-complex-bound states. But a user-friendly tool to visualize and quantify such states is lacking. SMTrackR, a Bioconductor package visualizes protein-DNA binding states on individual sequenced DNA molecules. SMTrackR queries the single-molecule footprint database we built and hosted at Galaxy Server. It comprises of BigBed files generated from NOMe-seq and dSMF datasets. SMTrackR exploits UCSC REST API to query a BigBed file and plot footprint heatmap categorized in different binding states as well as report their occupancies.

```{r, echo=FALSE, out.width="70%", fig.align="center"}
knitr::include_graphics("images/schematic_for_vignettes.png")
```

## Installation
```{r, echo = TRUE}
# if (!require("BiocManager", quietly = TRUE))
#     install.packages("BiocManager")
# 
# BiocManager::install("SMTrackR")
# rmarkdown::html_vignette
```
## Loading the package
```{r Load package, echo=TRUE}
library(SMTrackR)
```
## Plot Single Molecules from SMF Data

`SMTrackR::plotFootprints()` will generate the heatmap `pdf` file stored in `<target_dir>/plots/<label>.heatmap.pdf` if `target_dir` option is provided, otherwise the plot will be saved in the `tempdir`, the fuction reports the path in both the cases. 
A `Gviz` compatible code can also be generated by running the `generateGvizCodeforSMF` function. See the code chunk below. 


```{r plot psuedo-bulk scNOMe-seq data, fig.width=4.5, fig.height=6, echo=TRUE}
SMTrackR::plotFootprints(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm39", type = "SMF", chromosome = "chr1",
                         start = 191450362,  end = 191450392, tr = "16cell",
                         label = "tss_mm39", fp_cap = 50, remove_dup = FALSE, target_dir = "smf")
SMTrackR::generateGvizCodeforSMF(organism = "mmusculus", model = "16cell", condition = "WT",
                         genome_assembly = "mm39", type = "SMF", chromosome = "chr1",
                         start = 191450362,  end = 191450392, tr = "16cell",
                         label = "tss_mm39", fp_cap = 50, remove_dup = FALSE, gviz_left = 500,
                         gviz_right = 500, target_dir = "smf")
```

NOTE: The Nov 2020 Ensembl Archive ([nov2020.archive.ensembl.org](https://nov2020.archive.ensembl.org/) is down almost always. Thus, it is a gentle advice to use [may2025 archive](https://may2025.archive.ensembl.org/index.html). You have to manually change the host argument in the gviz R file (for instance, tss_mm39.gviz.R) according to the need. Snapshot for heatmap embedded with ideogram and axis is below.

```{r, echo=FALSE, out.width="100%", fig.align="center"}
knitr::include_graphics("images/tss_mm39.gviz.png")
```
 

## Plot Single Molecules from dSMF Data

To learn more about dSMF data, please read the article [Krebs et al., Mol. Cell., 2017](https://pubmed.ncbi.nlm.nih.gov/28735898/). Briefly, it uses two exogenous methyltransferases in tandem to map protein-DNA binding on individual sequenced DNA molecules.

The command below will generate `plots/peak229.plot.pdf` file.
```{r Plot dSMF data, fig.width=4.5, fig.height=6, echo=TRUE}
SMTrackR::plotFootprints(target_dir = "dsmf")
```

Below is the snapshot (png) of the saved pdf. 

```{r, echo=FALSE, out.width="100%", fig.align="center"}
knitr::include_graphics("images/peak229.heatmap.png")
```
 

## Plot Single Molecules from Nanopore Data

Running the command below will generate a pdf file `plots/smac_seq.plot.pdf`. 

```{r Plot Methylation Calls on Nanopore Reads, fig.width=10, fig.height=5, echo=TRUE}
SMTrackR::plotMethylationCallsNanopore(target_dir = "nanopore") 
```

Here is the `png` version of the saved pdf. 

```{r, echo=FALSE, out.width="100%", fig.align="center"}
knitr::include_graphics("images/smac_seq.heatmap.png")
```


## Listing Available Track

All uptodate tracks are available [here](https://docs.google.com/spreadsheets/d/1eu2Y2S0lyAUqxlvtnPBCO55OrxidYV7SwVRkqelPcKk/edit?gid=0#gid=0) and can be listed using the following command.  
```{r List available tracks, echo = TRUE}

#SMTrackR::listTracks()
```



## Session Info
```{r Session Info, echo = TRUE}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/generateGvizCode.R
\name{generateGvizCodeforSMF}
\alias{generateGvizCodeforSMF}
\title{Visualize Single Molecule Footprint Patterns with Ideogram and Gene Tracks}
\usage{
generateGvizCodeforSMF(
  organism = "demlanogaster",
  model = "S2",
  condition = "WT",
  genome_assembly = "dm6",
  type = "dSMF",
  chromosome = "chr2L",
  start = 480290,
  end = 480320,
  tr = "fp_and_mvec",
  label = "peak229",
  span_left = 150,
  span_right = 150,
  remove_dup = FALSE,
  fp_cap = 50,
  gviz_left = 1000,
  gviz_right = 1000,
  target_dir = ""
)
}
\arguments{
\item{organism}{Organism code (default: "dmelanogaster")}

\item{model}{Biological model/system (default: "S2" cells)}

\item{condition}{Experimental condition (default: "WT")}

\item{genome_assembly}{Genome version (default: "dm6")}

\item{type}{Data type ("dSMF" = dual enzyme Single Molecule Footprinting)}

\item{chromosome}{Chromosome ID (e.g., "chr2L")}

\item{start}{Genomic start position (numeric/character)}

\item{end}{Genomic end position (numeric/character)}

\item{tr}{Track name for BigBed file resource (default: "fp_and_mvec")}

\item{label}{Plot title annotation}

\item{span_left}{Upstream window size from region (default: 150)}

\item{span_right}{Downstream window size from region (default: 150)}

\item{remove_dup}{Remove duplicate reads? (default: FALSE)}

\item{fp_cap}{Maximum footprint value for y-axis scaling (default: 50)}

\item{gviz_left}{left zoom (bases) from the start}

\item{gviz_right}{right zoom (bases) from the end}

\item{target_dir}{destination directory (must be the same used in `plotFootprints` function)}
}
\value{
Saves a heatmap in pdf, png, and eps file formats.
}
\description{
Generates Gviz-compatible R code that puts SMF footprints below ideogram and genetracks. This call assumes that you have already ran `plotFootprints` function. 
Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
}
\details{
This function generates a R code running which one can get ideogram, genetracks and SMF heatmap altogether in one plot.
}
\examples{
# Basic usage with default parameters
generateGvizCodeforSMF(organism = "mmusculus", model = "16cell", 
                         condition = "WT", genome_assembly = "mm10",
                         type = "SMF", chromosome = "chr1",start = 191718250,
                         end = 191718280, tr = "16cell", label = "tss",
                         fp_cap = 50, remove_dup = FALSE, gviz_left = 500,
                         gviz_right = 500, target_dir = "")
                         

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method.R
\name{listTracks}
\alias{listTracks}
\title{Discover Available Single Molecule Data Tracks}
\usage{
listTracks()
}
\value{
A tibble containing track metadata with columns:
\itemize{
  \item organism: Species identifier (e.g. "dmelanogaster")
  \item genome_assembly: Reference genome version
  \item condition: Experimental condition
  \item model: Biological model/system
  \item track_name: Identifier for `tr` parameter in `plotFootprints`
  \item data_type: NOME-seq protocol variant
  \item bigbed_url: Cloud-hosted data location
}
}
\description{
Retrieves track metadata from a centralized Google Sheet containing
organism-specific single-molecule datasets and experimental conditions.
}
\examples{
# List all available tracks from default repository
listTracks()


}
\seealso{
`plotFootprints()`: Use track names from this list to visualize specific datasets
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method.R
\name{plotMethylationCallsNanopore}
\alias{plotMethylationCallsNanopore}
\title{Visualize Single Molecule Footprint Patterns}
\usage{
plotMethylationCallsNanopore(
  organism = "scerevisiae",
  model = "BY4741 strain",
  condition = "WT",
  genome_assembly = "sacCer3",
  type = "SMF",
  chromosome = "chrIII",
  start = 114300,
  end = 114600,
  tr = "nanopore_meth_calls",
  label = "smac_seq",
  span_left = 1000,
  span_right = 1000,
  stride = 5,
  target_dir = ""
)
}
\arguments{
\item{organism}{Organism code (default: "scerevisiae")}

\item{model}{Biological model/system (default: "BY4741 strain")}

\item{condition}{Experimental condition (default: "WT")}

\item{genome_assembly}{Genome version (default: "sacCer3")}

\item{type}{Data type ("Nanopore" = dual enzyme Single Molecule Footprinting)}

\item{chromosome}{Chromosome ID (e.g., "chrIII")}

\item{start}{Genomic start position (numeric/character)}

\item{end}{Genomic end position (numeric/character)}

\item{tr}{Track name for BigBed file resource (default: "nanopore_meth_calls")}

\item{label}{Plot title annotation (default: "smac_seq")}

\item{span_left}{Upstream window size from region (default: 1000)}

\item{span_right}{Downstream window size from region (default: 1000)}

\item{stride}{sliding window used for singal aggregation}

\item{target_dir}{destination directory where outputs will be stored}
}
\value{
Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
}
\description{
Generates footprint plots from NOME-seq data within specified genomic regions.
Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
}
\details{
This function retrieves and visualizes DNA accessibility patterns from single-molecule data:
- Integrates with UCSC-style track hubs via `tr` parameter
- Automatically handles coordinate conversion for dm6 genome
- Implements dynamic y-axis scaling using `fp_cap`
}
\examples{
# Basic usage with default parameters
plotMethylationCallsNanopore()

# Custom genomic region analysis

plotMethylationCallsNanopore (
        organism = "scerevisiae", model = "BY4741 strain",
        condition = "WT", genome_assembly = "sacCer3",
        type = "SMF", chromosome = "chrIII",
        start = 114300, end = 114600,
        tr = "nanopore_meth_calls", label = "smac_seq",
        span_left = 1000, span_right = 1000, stride = 5, target_dir = "")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method.R
\name{plotFootprintsUsingLocalBigBed}
\alias{plotFootprintsUsingLocalBigBed}
\title{Visualize Single Molecule Footprint Patterns using Local BigBed file}
\usage{
plotFootprintsUsingLocalBigBed(
  bigBed = "",
  organism = "dmelanogaster",
  model = "S2",
  condition = "WT",
  genome_assembly = "dm3",
  chromosome = "chr2L",
  start = 480290,
  end = 480320,
  label = "peak229",
  span_left = 150,
  span_right = 150,
  remove_dup = FALSE,
  fp_cap = 50,
  target_dir = ""
)
}
\arguments{
\item{bigBed}{BigBed file path (e.g., "demo.bb")}

\item{organism}{Organism code (default: "dmelanogaster")}

\item{model}{Biological model/system (default: "S2" cells)}

\item{condition}{Experimental condition (default: "WT")}

\item{genome_assembly}{Genome version (default: "dm6")}

\item{chromosome}{Chromosome ID (e.g., "chr2L")}

\item{start}{Genomic start position (numeric/character)}

\item{end}{Genomic end position (numeric/character)}

\item{label}{Plot title annotation}

\item{span_left}{Upstream window size from region (default: 150)}

\item{span_right}{Downstream window size from region (default: 150)}

\item{remove_dup}{Remove duplicate reads? (default: FALSE)}

\item{fp_cap}{Maximum footprint value for y-axis scaling (default: 50)}

\item{target_dir}{destination directory where outputs will be stored}
}
\value{
Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
}
\description{
Generates footprint plots from SMF/dSMF data within specified genomic regions.
Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
}
\details{
This function uses local SMF/dSMF bigBed file and plot heatmap
}
\examples{
# Basic usage with default parameters
plotFootprintsUsingLocalBigBed()

# Custom genomic region analysis
plotFootprintsUsingLocalBigBed(
  bigBed = "inst/extdata/demo.bb", organism = "dmelanogaster",
  model = "S2", condition = "WT", genome_assembly = "dm3",
  chromosome = "chr2L", start = 480290, end = 480320, label = "peak229")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method.R
\name{plotFootprints}
\alias{plotFootprints}
\title{Visualize Single Molecule Footprint Patterns}
\usage{
plotFootprints(
  organism = "dmelanogaster",
  model = "S2",
  condition = "WT",
  genome_assembly = "dm6",
  type = "dSMF",
  chromosome = "chr2L",
  start = 480290,
  end = 480320,
  tr = "fp_and_mvec",
  label = "peak229",
  span_left = 150,
  span_right = 150,
  remove_dup = FALSE,
  fp_cap = 50,
  target_dir = ""
)
}
\arguments{
\item{organism}{Organism code (default: "dmelanogaster")}

\item{model}{Biological model/system (default: "S2" cells)}

\item{condition}{Experimental condition (default: "WT")}

\item{genome_assembly}{Genome version (default: "dm6")}

\item{type}{Data type ("dSMF" = dual enzyme Single Molecule Footprinting)}

\item{chromosome}{Chromosome ID (e.g., "chr2L")}

\item{start}{Genomic start position (numeric/character)}

\item{end}{Genomic end position (numeric/character)}

\item{tr}{Track name for BigBed file resource (default: "fp_and_mvec")}

\item{label}{Plot title annotation}

\item{span_left}{Upstream window size from region (default: 150)}

\item{span_right}{Downstream window size from region (default: 150)}

\item{remove_dup}{Remove duplicate reads? (default: FALSE)}

\item{fp_cap}{Maximum footprint value for y-axis scaling (default: 50)}

\item{target_dir}{destination directory where outputs will be stored}
}
\value{
Saves a heatmap in pdf, png, and eps file formats. Also, occupancies are saved in a tsv file
}
\description{
Generates footprint plots from NOME-seq data within specified genomic regions.
Designed for Drosophila melanogaster analysis with expandable parameters for other organisms.
}
\details{
This function retrieves and visualizes DNA accessibility patterns from single-molecule data:
- Integrates with UCSC-style track hubs via `tr` parameter
- Automatically handles coordinate conversion for dm6 genome
- Implements dynamic y-axis scaling using `fp_cap`
}
\examples{
# Basic usage with default parameters
plotFootprints()

# Custom genomic region analysis
plotFootprints(
  chromosome = "chr2L", start = 480290, end = 480320, label = "peak229")

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/method.R
\name{plotMethylationCallsNanoporeUsingLocalBigBed}
\alias{plotMethylationCallsNanoporeUsingLocalBigBed}
\title{Visualize aggregate methylation calls from ONT sequencing data}
\usage{
plotMethylationCallsNanoporeUsingLocalBigBed(
  bigBed = "",
  chromosome = "chrIII",
  start = 114300,
  end = 114600,
  label = "smac_seq",
  span_left = 1000,
  span_right = 1000,
  remove_dup = FALSE,
  stride = 5,
  target_dir = ""
)
}
\arguments{
\item{bigBed}{BigBed file path (e.g., "demo.bb")}

\item{chromosome}{Chromosome ID (e.g., "chr2L")}

\item{start}{Genomic start position (numeric/character)}

\item{end}{Genomic end position (numeric/character)}

\item{label}{Plot title annotation}

\item{span_left}{Upstream window size from region (default: 150)}

\item{span_right}{Downstream window size from region (default: 150)}

\item{remove_dup}{Remove duplicate reads? (default: FALSE)}

\item{stride}{a window size used for averaging the methylation call values}

\item{target_dir}{destination directory where outputs will be stored}
}
\value{
Saves a methylation calls (binary) heatmap in pdf, png, and eps file formats.
}
\description{
Generates heatmap of methylation calls from likes of SMAC-seq datasets.
currently has data from Yeast (sacCer3)
}
\details{
This function uses local SMF/dSMF bigBed file and plot heatmap
}
